/*
	Programa para atualizacao de versao do PLAN
	R. Pragana - 03/21/91
*/

#include <stdio.h>
#include <alloc.h>
#include <io.h>
#include <fcntl.h>
#include <dos.h>

typedef unsigned char byte;
#define BLKLEN (16*1024)

void exerro( s )
char *s; {
	fprintf(stderr,s);
	fprintf(stderr,"\nConsulte a Percomp!\n");
	exit(1);
}

main() {
	byte *exe;
	byte *dba;
	byte *dba1;
	union byte_p {
		byte *p;
		struct {
			unsigned o,s;
		} r;
	} tmp;
	FILE *f;
	unsigned toff,tseg;
	int  h;
	long int len;
	unsigned long lenexe,lendba,lendba1;
	/* envia mensagem "em processamento" */
	printf("\n\nSistema de Atualizao");
	printf("\n\nPercomp Sistemas de Computao Ltda");
	printf("\nRecife, Pernambuco (081)231-1427\n\n");
	printf("Aguarde...");
	/* obtem arquivo plan.dba */
	if ((f=fopen("plan.dba","rb"))==NULL) exerro("\nDisco adulterado");
	h=fileno(f);
	lendba=filelength(h);
	if(lendba==-1) exerro("\nArquivo errado!");
	dba=(byte *)farmalloc(lendba);
/*	printf("\n[%d]-PLAN.DBA <%ld> --> %x:%x",
		h,lendba,FP_SEG(dba),FP_OFF(dba));
*/	if(dba==NULL) exerro("\nMemria insuficiente");
	printf("\nLendo bases de dados...");
	fread(dba,1,lendba,f);
	fclose(f);
	/* obtem arquivo plan1.dba */
	if ((f=fopen("plan1.dba","rb"))==NULL) exerro("\nDisco adulterado");
	h=fileno(f);
	lendba1=filelength(h);
	dba1=(byte *)farmalloc(lendba1);
	if(dba1==NULL) exerro("\nMemria insuficiente");
	fread(dba1,1,lendba1,f);
	fclose(f);
	/* obtem arquivo plan.exe */
	if ((f=fopen("plan.exe","rb"))==NULL) exerro("\nDisco adulterado");
	h=fileno(f);
	lenexe=filelength(h);
	exe=(byte *)farmalloc(lenexe+BLKLEN);
	if(exe==NULL) exerro("\nMemria insuficiente");
	tmp.p=exe;
	len=lenexe;
	printf("\nLendo executvel...");
	while (len>0) {
		if (len>=BLKLEN) {
			/* printf("\n%Fp, %Fp - %li",exe,tmp.p,len); */
			fread(tmp.p,1,BLKLEN,f);
		}
		else {
			/* printf("\n%Fp - %li",tmp.p,len); */
			fread(tmp.p,1,len,f);
		}
		tmp.r.s+=BLKLEN/16;
		len-=BLKLEN;
	}
	fclose(f);
	/* Solicita a troca de disquetes */
	printf("\n\nTroque o disquete no drive A: e bata return.\07");
	while (bioskey(1)!=0) bioskey(0);
	bioskey(0);
	/* apaga arquivos existentes */
	printf("\nGravando arquivos, aguarde...");
	unlink("plan.dba");
	unlink("plan1.dba");
	unlink("plan.exe");
	/* grava arquivo plan.exe */
	if ((f=fopen("plan.exe","wb"))==NULL) exerro("\nErro na gravao");
	tmp.p=exe;
	len=lenexe;
	while (len>0) {
		if (len>=BLKLEN)
			fwrite(tmp.p,1,BLKLEN,f);
		else
			fwrite(tmp.p,1,len,f);
		tmp.r.s+=BLKLEN/16;
		len-=BLKLEN;
	}
	fclose(f);
	/* grava arquivo plan.dba */
	if ((f=fopen("plan.dba","wb"))==NULL) exerro("\nErro na gravao");
	fwrite(dba,1,lendba,f);
	fclose(f);
	/* grava arquivo plan1.dba */
	if ((f=fopen("plan1.dba","wb"))==NULL) exerro("\nErro na gravao");
	fwrite(dba1,1,lendba1,f);
	fclose(f);
	/* indica final da operao */
	printf("\n\nOperao concluida com sucesso!\n");
}