;
;	Functions for low-level support -- MCDebugger
;	(C) 1992 R. Pragana
;

MCDCNTX_TEXT	SEGMENT  BYTE PUBLIC 'CODE'
MCDCNTX_TEXT	ENDS
_DATA	SEGMENT  WORD PUBLIC 'DATA'
_DATA	ENDS
_BSS	SEGMENT  WORD PUBLIC 'BSS'
_BSS	ENDS

extrn	proc_Int03: far

DGROUP	GROUP	_BSS,	_DATA
	ASSUME  CS: MCDCNTX_TEXT, DS: DGROUP, SS: DGROUP, ES: DGROUP
MCDCNTX_TEXT      SEGMENT
;
registers struc
r_cs	dw	?
r_ip	dw	?
r_bx	dw	?
r_cx	dw	?
r_dx	dw	?
r_bp	dw	?
r_ds	dw	?
r_es	dw	?
r_ss	dw	?
r_sp	dw	?
r_si	dw	?
r_di	dw	?
registers ends

	PUBLIC save_context
save_context proc far
;	arg	regs:far
	push	bp
	mov	bp,sp
	push	si
	push	es
;	les	dx,[regs]
	les	si,dword ptr [bp+6]
	mov	es:[si].r_di,di
	mov	es:[si].r_bx,bx
	mov	es:[si].r_cx,cx
	mov	es:[si].r_dx,dx
	mov	ax,ds
	mov	es:[si].r_ds,ax
	mov	ax,ss
	mov	es:[si].r_ss,ax
	mov	ax,[bp]
	mov	es:[si].r_bp,ax
	mov	ax,[bp+2]
	mov	es:[si].r_ip,ax
	mov	ax,[bp+4]
	mov	es:[si].r_cs,ax
	mov	ax,sp
	add	ax,10		; subtract es,dx,bp,ip & cs on the stack
	mov	es:[si].r_sp,ax
	mov	ax,[bp-2]
	mov	es:[si].r_si,ax
	mov	ax,[bp-4]
	mov	es:[si].r_es,ax
	xor	ax,ax
	pop	es
	pop	si
	pop	bp
	ret
save_context endp

	PUBLIC restore_context
restore_context proc far
	push	bp
	mov	bp,sp
	les	si,dword ptr [bp+6]
	cli
	mov	ax,es:[si].r_ss
	mov	ss,ax
	mov	ax,es:[si].r_sp
	mov	sp,ax
	sti
	mov	ax,es:[si].r_cs
	push	ax
	mov	ax,es:[si].r_ip
	push	ax
	mov	ax,es:[si].r_si
	push	ax
	mov	ax,es:[si].r_es
	push	ax
	mov	bx,es:[si].r_bx
	mov	cx,es:[si].r_cx
	mov	dx,es:[si].r_dx
	mov	ds,es:[si].r_ds
	mov	di,es:[si].r_di
	mov	bp,es:[si].r_bp
	pop	es
	pop	si
	mov	ax,1
	ret
restore_context endp

	public Int03
Int03	proc	far
	push	bp
	mov	bp,sp
	push	ds
	push	ax
	dec	word ptr [bp+2]		; atualiza o IP para re-executar
	mov	ax,DGROUP
	mov	ds,ax
	push	[bp+2]
	push	[bp+4]
	call	far ptr proc_Int03
	add	sp,4
	pop	ax
	pop	ds
	pop	bp
	iret
Int03	endp

;	public Int10
;Int10	proc	far
;	push	bp
;	mov	bp,sp
;	push	ds
;	push	ax
;	mov	ax,DGROUP
;	mov	ds,ax
;	pop	ax
;	push	dx
;	push	ax
;	call	far ptr proc_Int10
;	add	sp,4
;	pop	ds
;	pop	bp
;	iret
;Int10	endp

MCDCNTX_TEXT	ENDS
END
