/*
** 	MCdebug -- Debugger for MCobol programs
**	(C) 1992 R. Pragana  P.O. Box 7440 Recife Brazil
**	version 1.1 
*/

code = 4000

project "mcdebug"
include "tdoms.pro"

global DATABASE
/* lineinp */
	insmode
	lineinpstate(STRING,COL)
	lineinpflag
/* pulldown */
	pdwstate(ROW,COL,SYMBOL,ROW,COL)
/* diversos */
	console_txt( string,integer,integer )
	initline( integer )
	determ syslist( integer,integer )	/* pointer to syslist array */
	listed( integer,integer )		/* lines listed (list_lines) */		
	ip( integer,integer )			/* last CS:IP */
	initializing
	inaction
	btndx( bt_selector )
global DOMAINS
	file = arquivo
	db_selector = dba
	source = s( integer,string )

global predicates
	useraction
	breakpt( integer,integer,integer ) - (i,i,i) language c
	crestart - language c
	install_trap( integer ) - (i) language c
	clr_breakpt( integer,integer ) - (i,i) language c
	list_breakpt( integerlist ) - (o) language c
	wait_breakpt - language c
	toggle_breakpt( integer,integer,integer ) - (i,i,i) language c
	frontlabel( string,string,string ) - (i,o,o) language c
	cget_string( integer,integer,integer,string ) - (i,i,i,o) language c
	cget_string1( integer,integer,integer,string ) - (i,i,i,o) language c

DATABASE - symb_table
	v( string,integer,integer,integer,char )
						/* variable definition */
	l( integer,integer,string,string,integer )	
						/* line number */
	llist( integerlist )			/* all line numbers */
	lbl( string,integer )			/* label address */
	tbkp( integer )				/* temporary breakpoint */
	determ vars( stringlist )		/* all variables */
	determ varBase( integer,integer )	/* pointer to base address */
	determ var_selected( integer )		/* last var selection */
	determ term_process( integer )		/* process number */
	determ proc_ptr( integer,integer )	/* pointer to process array */
	/*determ source_text( string )*/	/* source file string */
/*	s( integer,string )	*/		/* source lines */
DATABASE - select_table
	determ v_displ( stringlist )		/* visible variables (watch) */
DATABASE - setup_db
	window_setup( integer,integer,integer,integer,integer,integer,integer )
include "tpreds.pro"
include "lineinp.pro"
include	"status.pro"
include "filename.pro"
include "longmenu.pro"
include "pulldown.pro"

PREDICATES
/*	message( string )*/
	escolhe_terminal( integer )
	load_source( string )
	check_ip
	atualiza
	restart
	check_installed
	check_used_terminal( integer )
	/*display_header( integer )*/
	kind_to_step( integer,integer )
	next_line( integer,integer,integer,string,string,integer )
	set_bkpt( integer,integer,integer,string,string,integer )
	kill_tmpbkpt
	locateAfterIP( integer,integer )
	locateAfterIP( integerlist,integer,integer )
	locateNext( integer,integer )
	locateNext( integerlist,integer,integer )
	label_kind( string,integer )
	all_lines( integerlist )
	intl_strl( integerlist,stringlist )
	clr_all_breakpoints
	get_window_setup( integer,integer,integer,integer,integer,integer,integer )
	escolha_janela( integer )
	read_source( string )
	list_lines( integer,integer,integer )
	show_lines( ref,integer,integer )
	goto_line( integer )
	nondeterm link_next_bp( integer,integer,integer )
	current_ip( integer,integer )
	findline( integer )
	console
	console_send(char)
	key_map(integer,char)
	scan_map(integer,char)
	get_cursor(integer,integer)
	select_var(string)
	select_var_base( string )
	select_var_index( string,string )
	modify( string )
	save_string( string,integer,integer,integer )
	address_var( string,integer,integer,integer )
	display_var_list( stringlist )
	display_var_list( stringlist,integer,integer )
	display_var( string,string )
	display_var_name( string,string )
	conv_index( stringlist,stringlist )
	list_variables
	readunsigned( integer )
	readfarptr( integer,integer )
	readsymbol( string )
	frontname( string,string,string,integer )
	read_symb_table( string )
	calc_base_addr( integer,integer ) 
	index(integer,stringlist,string)
	append(stringlist,stringlist,stringlist)
	delete( stringlist,string,stringlist )
	nondeterm for( integer,integer,integer )
	nondeterm repeat_for( integer,integer )
	nondeterm for_each( integer,integerlist )
	sort(stringlist,stringlist)
	split(string,stringlist,stringlist,stringlist)
	display_line( integer )
	scr(KEY)
	endkey(KEY)

/*clauses
	message( Str ) :-
		makewindow(3,9,32,"frontlabel",12,20,4,37),
		write( Str ), 
		readdevice(OldDev), readdevice(stdin),
		readchar(_), readdevice(OldDev), removewindow, !.
*/	
include "mcdshow.pro"
include "mcdclaus.pro"
include "mcdmain.pro"
