CLAUSES
	useraction :-
		initializing, !.
	useraction :-
		inaction, !.
	useraction :-
		assert( inaction ),
		check_ip, 
		retractall( inaction ), !. 
			
	check_ip :-
		current_ip( CS,IP ),
		ip( CS,IP ), !.
	check_ip :-
		current_ip( CS,IP ),
		retractall(ip(_,_)), assert(ip(CS,IP)),
		atualiza, !.
	check_ip :- !.
		
	restart :-
		crestart,
		current_ip(_,IP), l(_,IP,_,_,_), !.
	restart :-
		makewindow(3,9,32,"-- ATENAO --",10,20,4,30),
		write("Terminal no meio de um"), nl,
		write("CALL ou ACCEPT - Verifique!"),
		readchar(_), removewindow, !.

	label_kind( "normal",0 ):-!.
	label_kind( "desvio condicional",1 ):-!.
	label_kind( "perform",3 ):-!.
	label_kind( "desvio incondicional",_ ):-!.

	kind_to_step( 3,9 ):-!.
	kind_to_step( X,X ):-!.
		
	all_lines( L ) :-
		llist( L ), !.
	all_lines( L ) :-
		findall( Lin,l(Lin,_,_,_,_),L ), assert(llist(L)), !.
		
	locateAfterIP( Lin,IP ) :-
		l( Lin,IP,_,_,_ ), !.	/* soluo simplista primeiro */
	locateAfterIP( Lin,IP ) :-
		savestatus(OldSt), changestatus("*****  A G U A R D E *****"),
		all_lines( LList ),
		locateAfterIP( LList,Lin,IP ),
		changestatus(OldSt), !.

	locateAfterIP( [Lin,Previous|_],Lin,IP ) :-
		l( Previous,IP2,_,_,_ ), IP2<IP,
		l( Lin,IP1,_,_,_ ), IP1>=IP, !.
	locateAfterIP( [_|T],Lin,IP ) :-
		!, locateAfterIP( T,Lin,IP ).
		
	locateNext( LinC,Lin ) :-
		all_lines(LList),
		locateNext( LList,LinC,Lin ).
		
	locateNext( [Next,Lin|_],Lin,Next ) :- !.
	locateNext( [_|T],Lin,Next ) :-
		!, locateNext(T,Lin,Next).
	
	next_line( Lin,CS,IP,Label,Label2,Kind ) :-
		findline( LinC ), l(LinC,_,Label,Label2,Kind),
		savestatus(OldSt),
		changestatus("AGUARDE... calculando prximas paradas"),
		current_ip( CS,_ ), 
		locateNext(LinC,Lin),
		l(Lin,IP,_,_,_),
		changestatus(OldSt), !.
		
	kill_tmpbkpt :-
		current_ip( CS,_ ),
		tbkp( Lin ), l(Lin,IP,_,_,_),
		clr_breakpt( CS,IP ), fail.
	kill_tmpbkpt :- retractall(tbkp(_)).
	
	set_bkpt( Lin,CS,IP,_,_,0 ) :-
		assert(tbkp(Lin)),
		breakpt( CS,IP,Lin ), !.
	set_bkpt( Lin,CS,IP,Label,_,1 ) :-
		assert(tbkp(Lin)),
		breakpt( CS,IP,Lin ),
		lbl( Label,IPtmp ),
		locateAfterIP( Lin2,IPtmp ),
		l(Lin2,IP2,_,_,_),
		assert(tbkp(Lin2)),
		breakpt( CS,IP2,Lin2 ), !.
	set_bkpt( Lin,CS,IP,Label,_,3 ) :-
		breakpt( CS,IP,Lin ),
		lbl( Label,IPtmp ),
		locateAfterIP( Lin2,IPtmp ),
		l(Lin2,IP2,_,_,_),
		breakpt( CS,IP2,Lin2 ), !.
	set_bkpt( Lin,CS,IP,_,_,9 ) :-	/* step over 'perform' */
		breakpt( CS,IP,Lin ), !.
	set_bkpt( Lin,CS,IP,Label,Label2,6 ) :-
		breakpt( CS,IP,Lin ),
		lbl( Label,IPtmp ),
		locateAfterIP( Lin2,IPtmp ),
		l(Lin2,IP2,_,_,_),
		breakpt( CS,IP2,Lin2 ),
		lbl( Label2,IPtmp2 ),
		locateAfterIP( Lin3,IPtmp2 ),
		l(Lin3,IP3,_,_,_),
		breakpt( CS,IP3,Lin3 ), !.
	set_bkpt( _,CS,_,Label,_,_ ) :-
		lbl( Label,IPtmp ),
		locateAfterIP( Lin2,IPtmp ),
		l(Lin2,IP2,_,_,_),
		breakpt( CS,IP2,Lin2 ), !.
		
	display_line( NI ) :-
		savestatus(OldStat),
		changestatus("<F4>at aqui <F7>trace <F8>step <F2>inverte bkpt <F6>mostra linha <F9>run <ESC>"),
		shiftwindow(OldW), shiftwindow(2),
		retractall( initline(_) ), assert( initline(NI) ),
		assert(initializing),
		repeat,
		initline(Lin),
		goto_line(Lin),
		readkey(KEY),
		scr(KEY),
		endkey(KEY), !,
		changestatus(OldStat),
		shiftwindow(OldW),
		retractall(initializing).
	display_line( N ) :-
		readfilename(10,10,6,6,"cob","",Fn),
		read_source(Fn),
		!, display_line( N ).

scr(ins) :-
	current_ip( CS0,IP0 ), findline(Lin0),
	next_line( Lin,_,IP,Label,_,Kind ),
	l(Lin0,IP2,_,_,_),
	lbl( Label,IP1 ),
	label_kind( KindStr,Kind ),
	makewindow(3,14,14,"Posio Corrente",8,10,6,50),
	writef("CS:IP = %04x:%04x Linha: %d, Endr: %04x\n",CS0,IP0,Lin0,IP2),
	writef("Prxima: %d, IP = %04x\n",Lin,IP),
	writef("Label: %s , Endr: %04x\nTipo: %s",Label,IP1,KindStr),
	readchar(_), removewindow, !.
scr(pgup) :-
	initline(N), makewindow(_,_,_,_,_,_,Rows,_),
	N1=N-Rows+1, max( 0,N1,N2 ),
	retract(initline(_)), assert(initline(N2)), !.
scr(pgdn) :-
	initline(N),makewindow(_,_,_,_,_,_,Rows,_), N1=N+Rows-1,
	retract(initline(_)), assert(initline(N1)), !.
scr(up) :-
	initline(N), N1=N-1, N1>0,
	retract(initline(_)), assert(initline(N1)), !.
scr(down) :-
	initline(N), N1=N+1, N1>0,
	retract(initline(_)), assert(initline(N1)), !.

scr(fkey(9)) :- restart, wait_breakpt,
	findline( NewLin ),
	retract(initline(_)), assert(initline(NewLin)),
	atualiza, !.

scr(fkey(4)) :-
	initline( Lin ), l( Lin,IP,_,_,_ ), current_ip( CS,_ ),
	breakpt( CS,IP,Lin ), 
	restart, wait_breakpt,
	findline( NewLin ),
	retract(initline(_)), assert(initline(NewLin)),
	atualiza, !.
	
scr(fkey(2)) :-
	initline( Lin ), l( Lin,IP,_,_,_ ), current_ip( CS,_ ),
	toggle_breakpt( CS,IP,Lin ), !.

scr(fkey(6)) :-
	lineinput(18,4,40,9,32,"Vai para linha: ","",Str),
	str_int( Str,N ),
	retract(initline(_)), assert(initline(N)), !.

scr(fkey(7)) :- 			/* trace */
	next_line( Lin,CS,IP,Label,Label2,Kind ),
	kill_tmpbkpt,
	set_bkpt( Lin,CS,IP,Label,Label2,Kind ),
	restart, wait_breakpt,
	findline( NewLin ),
	retract(initline(_)), assert(initline(NewLin)),
	atualiza, !.

scr(fkey(8)) :- 			/* step */
	next_line( Lin,CS,IP,Label,Label2,Kind ),
	kill_tmpbkpt,
	kind_to_step( Kind,Kind1 ),
	set_bkpt( Lin,CS,IP,Label,Label2,Kind1 ),
	restart, wait_breakpt,
	findline( NewLin ),
	retract(initline(_)), assert(initline(NewLin)),
	atualiza, !.

scr(altc) :- pdwaction(6,0), /* console */
	check_ip, atualiza, !.
			
scr(esc).

endkey(esc).
