/*
**	Rotinas auxiliares do Sistema de Custos de Transportadoras
**
**	Rildo Pragana -- 11/18/90
*/

#include <stdio.h>
#include <bios.h>

void *malloc(unsigned size);
void *free(void *);
void *alloc_gstack(unsigned);

unsigned char fmtmap[512];

void tdsk_0( int trk, int *res ) /* testa disco A e devolve resultado */
{
	unsigned char sector, i;
	int n;
	sector=1;
	for (i=0;i<36;) {
		fmtmap[i++]=trk;	/* track */
		fmtmap[i++]=0;		/* head */
		fmtmap[i++]=sector++;   /* sector */
		fmtmap[i++]=2;		/* sector length */
	}
	biosdisk(5,0,0,trk,1,9,fmtmap);
	*res=biosdisk(4,0,0,trk,1,9,fmtmap);
	if (*res) {
		for (i=1;i<10;i++) {
			*res=biosdisk(2,0,0,trk,i,1,fmtmap);
			if (*res) {
				for (n=0;n<512;n++) {
					if (fmtmap[n]!=0xf6) {
						*res=n;
						break;
					}
				}
				*res+=(i*512);
				break;
			}
		}
	}
}

main() {
	int resultado,i;
	biosdisk(0,0,0,0,1,1,fmtmap);
	for (i=20;i<40;i++) {
		tdsk_0(i,&resultado);
		if (resultado==0)
			printf("Trilha %d: OK!\n",i);
		else
			printf("Trilha %d, setor/byte %d, com erro.\n",i,resultado);
	}
}
