	.287
MCCNTRL_TEXT	SEGMENT  BYTE PUBLIC 'CODE'
MCCNTRL_TEXT	ENDS
_DATA	SEGMENT  WORD PUBLIC 'DATA'
_DATA	ENDS
_BSS	SEGMENT  WORD PUBLIC 'BSS'
_BSS	ENDS
$$SYMBOLS	SEGMENT  BYTE PUBLIC 'DEBSYM'
$$SYMBOLS	ENDS
$$TYPES	SEGMENT  BYTE PUBLIC 'DEBTYP'
$$TYPES	ENDS
DGROUP	GROUP	_BSS,	_DATA
	ASSUME  CS: CHGSTK_TEXT, DS: DGROUP, SS: DGROUP, ES: DGROUP
CHGSTK_TEXT      SEGMENT
;
Ret_addrW label word
Ret_addr  dd	?
	public Sv_stk,Tmp_stk
Sv_stk	  dw	2 dup (?)
Tmp_stk	  dw	2 dup (?)

	PUBLIC	_save_stack
_save_stack proc far
	push	bp
	mov	bp,sp
	mov	cs:[Sv_stk],bp
	pop	bp
	ret
_save_stack endp

	PUBLIC  _tmp_stack
_tmp_stack proc far
	push	bp
	mov	bp,sp
	mov	cs:[Tmp_stk],bp
	mov	ax,ss
	mov	cs:[Tmp_stk+2],ax
	pop	ax
	mov	cs:Ret_addrW,ax
	pop	ax
	mov	cs:Ret_addrW+2,ax
	cli
	mov	ax,ds
	mov	ss,ax
	mov	sp,cs:[Sv_stk]
	sti
	jmp	dword ptr cs:[Ret_addr]
_tmp_stack endp

	PUBLIC _reset_stack
_reset_stack proc far
	pop	ax
	mov	cs:Ret_addrW,ax
	pop	ax
	mov	cs:Ret_addrW+2,ax
	cli
	mov	ax,cs:[Tmp_stk+2]
	mov	ss,ax
	mov	sp,cs:[Tmp_stk]
	sti
	pop	bp		; saved at tmp_stack
	pop	cx		; ignore old return addr
	pop	cx
	jmp	dword ptr cs:[Ret_addr]
_reset_stack endp

	PUBLIC	_data_stack
_data_stack proc far
;***** alternativa usando pilha na area de dados
	pop	ax
	mov	cs:Ret_addrW,ax
	pop	ax
	mov	cs:Ret_addrW+2,ax
	cli
	mov	ax,ds
	mov	ss,ax
	mov	sp,cs:[Sv_stk]
	sti
	jmp	dword ptr cs:[Ret_addr]
_data_stack endp

	PUBLIC	_chg_stack
_chg_stack proc far
;***** alternativa usando variaveis p/guardar o endereco de retorno
	pop	ax
	mov	cs:Ret_addrW,ax
	pop	ax
	mov	cs:Ret_addrW+2,ax
	pop	cx		; offset new stack
	pop	bx		; segment new stack
	pop	ax		; offset to add
	add	ax,cx
	cli
	mov	sp,ax
	mov	ss,bx
	sti
	jmp	dword ptr cs:[Ret_addr]
;	
;***** rotina funcional (original) para troca de pilha
;	arg	stkp:far, len:word	; somente p/o Turbo ASM
;	push	bp
;	mov	bp,sp
;	les	di,[bp+6]	; new stack ptr
;	add	di,[bp+10]	; offset to add
;	mov	ax,[bp+4]
;	sub	di,2
;	mov	es:di,ax
;	mov	ax,[bp+2]
;	sub	di,2
;	mov	es:di,ax
;	mov	ax,[bp]
;	sub	di,2
;	mov	es:di,ax
;	cli
;	mov	ax,es
;	mov	ss,ax	
;	mov	sp,di
;	sti
;	pop	bp
;	ret
_chg_stack endp

CHGSTK_TEXT	ENDS
END
