;	Static Name Aliases
;
;	$S265_paragraphs	EQU	paragraphs
;	$S266_malloc_blk	EQU	malloc_blk
;	$S267_env_seg	EQU	env_seg
;	$S270_mapmem	EQU	mapmem
;	$S272_sched_ticks	EQU	sched_ticks
;	$S273_alocpar	EQU	alocpar
;	$S274_nfopen	EQU	nfopen
;	$S278_Argtab	EQU	Argtab
	TITLE   htinst
;	NAME    htinst.C

	.287
HTINST_TEXT	SEGMENT  BYTE PUBLIC 'CODE'
HTINST_TEXT	ENDS
_DATA	SEGMENT  WORD PUBLIC 'DATA'
_DATA	ENDS
CONST	SEGMENT  WORD PUBLIC 'CONST'
CONST	ENDS
_BSS	SEGMENT  WORD PUBLIC 'BSS'
_BSS	ENDS
DGROUP	GROUP	CONST,	_BSS,	_DATA
	ASSUME  CS: HTINST_TEXT, DS: DGROUP, SS: DGROUP, ES: DGROUP
PUBLIC  _msg_blk_size
PUBLIC  _semaf_size
PUBLIC  _terminais
PUBLIC  _polling
PUBLIC  _uninstall
EXTRN	_exit:FAR
EXTRN	_clrscr:FAR
EXTRN	_desinstala:FAR
EXTRN	_fprintf:FAR
EXTRN	_calloc:FAR
EXTRN	_getargs:FAR
EXTRN	_malloc:FAR
EXTRN	_printf:FAR
EXTRN	_int86:FAR
EXTRN	_freemem:FAR
EXTRN	_disable:FAR
EXTRN	_set_bytes:FAR
EXTRN	__intdosx:FAR
EXTRN	_move_bytes:FAR
EXTRN	_keep_pgm:FAR
EXTRN	__iob:BYTE
EXTRN	_timer_data:WORD
EXTRN	__psp:WORD
EXTRN	_reg:BYTE
EXTRN	_oreg:BYTE
EXTRN	_segr:QWORD
EXTRN	_mcbp:DWORD
EXTRN	_mcbseg:DWORD
EXTRN	_running:DWORD
_DATA      SEGMENT
$SG279	DB	'desinstala pgm residente',  00H
$SG280	DB	'numero de ticks p/acesso ao OS',  00H
$SG281	DB	'paragrafos de memoria (16 bytes) reservadas',  00H
$SG282	DB	'handles para arquivos',  00H
$SG308	DB	0aH, 'Rede HandTerm n',  84H, 'o instalada!',  0aH,  00H
$SG310	DB	0aH, 'Rede HandTerm retirada da memoria',  0aH,  00H
$SG312	DB	0aH, 'Rede HandTerm j',  0a0H, ' foi instalada anteriormente.'
	DB	0aH,  00H
$SG322	DB	0aH, 'Rede de Microterminais HandTerm -- JLR Informatica Ltd'
	DB	'a 1993',  0aH,  00H
	PUBLIC	_terminais
_terminais	DB	00H
	ORG	$+4319
	PUBLIC	_msg_blk_size
_msg_blk_size	DW	087H
	PUBLIC	_semaf_size
_semaf_size	DW	06H
$S266_malloc_blk	DW	00H
$S267_env_seg	DW	00H
	PUBLIC	_polling
_polling	DB	00H
$S270_mapmem	DW	00H
	PUBLIC	_uninstall
_uninstall	DW	00H
$S272_sched_ticks	DW	0aH
$S273_alocpar	DW	028H
$S274_nfopen	DW	014H
$S278_Argtab	DW	0f1H
	DD	DGROUP:_uninstall
	DD	DGROUP:$SG279
	DW	073H
	DD	DGROUP:$S272_sched_ticks
	DD	DGROUP:$SG280
	DW	061H
	DD	DGROUP:$S273_alocpar
	DD	DGROUP:$SG281
	DW	06fH
	DD	DGROUP:$S274_nfopen
	DD	DGROUP:$SG282
_DATA      ENDS
_BSS      SEGMENT
$S265_paragraphs	DW 01H DUP (?)
;	.comm _timer_data,02H
;	.comm _reg,0eH
;	.comm _oreg,0eH
;	.comm _segr,08H
;	.comm _mcbp,04H
;	.comm _mcbseg,04H
_BSS      ENDS
HTINST_TEXT      SEGMENT
HTINST_TEXT      ENDS
CONST      SEGMENT
$T20000	DW SEG _running 
CONST      ENDS
HTINST_TEXT      SEGMENT
HTINST_TEXT      ENDS
CONST      SEGMENT
$T20001	DW SEG _reg 
CONST      ENDS
HTINST_TEXT      SEGMENT
HTINST_TEXT      ENDS
CONST      SEGMENT
$T20002	DW SEG _oreg 
CONST      ENDS
HTINST_TEXT      SEGMENT
HTINST_TEXT      ENDS
CONST      SEGMENT
$T20003	DW SEG _segr 
CONST      ENDS
HTINST_TEXT      SEGMENT
HTINST_TEXT      ENDS
CONST      SEGMENT
$T20004	DW SEG _mcbseg 
CONST      ENDS
HTINST_TEXT      SEGMENT
HTINST_TEXT      ENDS
CONST      SEGMENT
$T20005	DW SEG _mcbp 
CONST      ENDS
HTINST_TEXT      SEGMENT
HTINST_TEXT      ENDS
CONST      SEGMENT
$T20006	DW SEG __psp 
CONST      ENDS
HTINST_TEXT      SEGMENT
; Line 73
	PUBLIC	_mtnet_uninstall
_mtnet_uninstall	PROC FAR
	push	bp
	mov	bp,sp
; Line 74
	call	FAR PTR _disable
; Line 75
	inc	_polling
; Line 76
$WC292:
	mov	es,$T20000
	mov	ax,WORD PTR es:_running
	or	ax,WORD PTR es:_running+2
	jne	$WC292
; Line 77
	call	FAR PTR _desinstala
; Line 84
	mov	es,$T20001
	mov	BYTE PTR es:_reg+1,82
; Line 85
	mov	ax,OFFSET _segr
	mov	dx,SEG _segr
	push	dx
	push	ax
	mov	ax,OFFSET _oreg
	mov	dx,SEG _oreg
	push	dx
	push	ax
	mov	ax,OFFSET _reg
	mov	dx,SEG _reg
	push	dx
	push	ax
	call	FAR PTR __intdosx
	add	sp,12
; Line 86
	mov	es,$T20002
	mov	ax,WORD PTR es:_oreg+2
	sub	ax,2
	sub	dx,dx
	mov	es,$T20003
	mov	bx,WORD PTR es:_segr
	sub	cx,cx
	mov	dx,bx
	mov	es,$T20004
	mov	WORD PTR es:_mcbseg,ax
	mov	WORD PTR es:_mcbseg+2,dx
; Line 87
	les	bx,DWORD PTR es:_mcbseg
	mov	dx,es:[bx]
	sub	ax,ax
	mov	es,$T20005
	jmp	SHORT $L20008
$WC294:
; Line 90
	mov	es,$T20006
	mov	ax,es:__psp
	mov	es,$T20005
	les	bx,DWORD PTR es:_mcbp
	cmp	es:[bx+1],ax
	jne	$I296
; Line 91
	mov	es,$T20005
	mov	bx,OFFSET _mcbp
	mov	ax,es:[bx+2]
	inc	ax
	push	ax
	call	FAR PTR _freemem
	add	sp,2
; Line 92
$I296:
; Line 93
	mov	es,$T20005
	les	bx,DWORD PTR es:_mcbp
	mov	ax,es:[bx+3]
	mov	es,$T20005
	mov	bx,OFFSET _mcbp
	add	ax,es:[bx+2]
	inc	ax
	sub	dx,dx
	mov	dx,ax
	sub	ax,ax
	mov	ax,WORD PTR es:_mcbp
$L20008:
	mov	WORD PTR es:_mcbp,ax
	mov	WORD PTR es:_mcbp+2,dx
; Line 94
	mov	es,$T20005
	les	bx,DWORD PTR es:_mcbp
	cmp	BYTE PTR es:[bx],77
	je	$WC294
; Line 96
	mov	sp,bp
	pop	bp
	ret	

_mtnet_uninstall	ENDP
; Line 99
	PUBLIC	_mtnet_init
_mtnet_init	PROC FAR
	push	bp
	mov	bp,sp
	sub	sp,18
	push	si
; Line 101
;	argc = 6
;	argv = 8
;	handle_tbl = -4
;	old_tbl = -18
;	handle_cnt = -14
;	blk = -8
;	i = -10
; Line 107
	mov	ax,4
	push	ax
	mov	ax,OFFSET DGROUP:$S278_Argtab
	push	ds
	push	ax
	push	WORD PTR [bp+10]
	push	WORD PTR [bp+8]	;argv
	push	WORD PTR [bp+6]	;argc
	call	FAR PTR _getargs
	add	sp,12
; Line 108
	cmp	_uninstall,0
	jne	$JCC274
	jmp	$I306
$JCC274:
; Line 109
	mov	es,$T20001
	mov	WORD PTR es:_reg,-4352
; Line 110
	mov	ax,OFFSET _oreg
	mov	dx,SEG _oreg
	push	dx
	push	ax
	mov	ax,OFFSET _reg
	mov	dx,SEG _reg
	push	dx
	push	ax
	mov	ax,47
	push	ax
	call	FAR PTR _int86
	add	sp,10
; Line 111
	mov	es,$T20002
	test	BYTE PTR es:_oreg,15
	jne	$I307
; Line 112
	mov	ax,OFFSET DGROUP:$SG308
	push	ds
	push	ax
	mov	ax,OFFSET __iob+24
	mov	dx,SEG __iob
	push	dx
	push	ax
	call	FAR PTR _fprintf
	add	sp,8
; Line 113
	jmp	SHORT $I309
$I307:
; Line 114
	mov	es,$T20001
	mov	WORD PTR es:_reg,-4337
; Line 115
	mov	ax,OFFSET _oreg
	mov	dx,SEG _oreg
	push	dx
	push	ax
	mov	ax,OFFSET _reg
	mov	dx,SEG _reg
	push	dx
	push	ax
	mov	ax,47
	push	ax
	call	FAR PTR _int86
	add	sp,10
; Line 116
	mov	ax,OFFSET DGROUP:$SG310
	push	ds
	push	ax
	call	FAR PTR _printf
	add	sp,4
; Line 117
$I309:
; Line 118
	sub	ax,ax
	push	ax
	call	FAR PTR _exit
	add	sp,2
; Line 119
$I306:
; Line 120
	mov	es,$T20001
	mov	WORD PTR es:_reg,-4352
; Line 121
	mov	ax,OFFSET _oreg
	mov	dx,SEG _oreg
	push	dx
	push	ax
	mov	ax,OFFSET _reg
	mov	dx,SEG _reg
	push	dx
	push	ax
	mov	ax,47
	push	ax
	call	FAR PTR _int86
	add	sp,10
; Line 122
	mov	es,$T20002
	test	BYTE PTR es:_oreg,15
	je	$I311
; Line 123
	mov	ax,OFFSET DGROUP:$SG312
	push	ds
	push	ax
	mov	ax,OFFSET __iob+24
	mov	dx,SEG __iob
	push	dx
	push	ax
	call	FAR PTR _fprintf
	add	sp,8
; Line 124
	sub	ax,ax
	push	ax
	call	FAR PTR _exit
	add	sp,2
; Line 125
; Line 126
$I311:
	mov	ax,1
	push	ax
	call	FAR PTR _malloc
	add	sp,2
	mov	[bp-8],ax	;blk
	mov	[bp-6],dx
; Line 128
	mov	ax,dx
	mov	$S266_malloc_blk,ax
; Line 129
	cmp	$S274_nfopen,20
	jg	$JCC527
	jmp	$I313
$JCC527:
; Line 130
	mov	es,$T20006
	mov	dx,es:__psp
	sub	ax,ax
	or	al,52
	mov	[bp-4],ax	;handle_tbl
	mov	[bp-2],dx
; Line 131
	les	bx,[bp-4]	;handle_tbl
	mov	ax,es:[bx]
	mov	dx,es:[bx+2]
	mov	[bp-18],ax	;old_tbl
	mov	[bp-16],dx
; Line 132
	mov	ax,1
	push	ax
	push	$S274_nfopen
	call	FAR PTR _calloc
	add	sp,4
	les	bx,[bp-4]	;handle_tbl
	mov	es:[bx],ax
	mov	es:[bx+2],dx
; Line 133
	mov	es,$T20006
	mov	dx,es:__psp
	sub	ax,ax
	or	al,50
	mov	[bp-14],ax	;handle_cnt
	mov	[bp-12],dx
; Line 134
	push	$S274_nfopen
	mov	ax,255
	push	ax
	mov	es,[bp-2]
	push	WORD PTR es:[bx+2]
	push	WORD PTR es:[bx]
	call	FAR PTR _set_bytes
	add	sp,8
; Line 135
	les	bx,[bp-14]	;handle_cnt
	push	WORD PTR es:[bx]
	push	WORD PTR [bp-16]
	push	WORD PTR [bp-18]	;old_tbl
	les	bx,[bp-4]	;handle_tbl
	push	WORD PTR es:[bx+2]
	push	WORD PTR es:[bx]
	call	FAR PTR _move_bytes
	add	sp,10
; Line 136
	les	bx,[bp-14]	;handle_cnt
	mov	ax,$S274_nfopen
	mov	es:[bx],ax
; Line 137
; Line 138
$I313:
	mov	BYTE PTR [bp-10],0	;i
$F315:
; Line 139
	mov	al,135
	mul	BYTE PTR [bp-10]	;i
	mov	si,ax
	mov	BYTE PTR _terminais[si+2],0
; Line 140
	sub	al,al
	mov	BYTE PTR _terminais[si+4],al
	mov	BYTE PTR _terminais[si+3],al
; Line 141
	mov	BYTE PTR _terminais[si+5],al
; Line 142
	inc	BYTE PTR [bp-10]	;i
	cmp	BYTE PTR [bp-10],32	;i
	jb	$F315
; Line 143
	pop	si
	mov	sp,bp
	pop	bp
	ret	

_mtnet_init	ENDP
; Line 146
	PUBLIC	_mtnet_install
_mtnet_install	PROC FAR
	push	bp
	mov	bp,sp
	sub	sp,2
;	i = -2
; Line 148
	call	FAR PTR _clrscr
; Line 149
	inc	_polling
; Line 151
	mov	ax,OFFSET DGROUP:$SG322
	push	ds
	push	ax
	call	FAR PTR _printf
	add	sp,4
; Line 152
	mov	WORD PTR [bp-2],0	;i
$F323:
; Line 153
	mov	ax,135
	imul	WORD PTR [bp-2]	;i
	mov	bx,ax
	mov	BYTE PTR _terminais[bx+1],0
	inc	WORD PTR [bp-2]	;i
	cmp	WORD PTR [bp-2],32	;i
	jl	$F323
; Line 154
	call	FAR PTR _disable
; Line 155
	push	$S272_sched_ticks
	push	$S265_paragraphs
	call	FAR PTR _keep_pgm
; Line 156
	mov	sp,bp
	pop	bp
	ret	

_mtnet_install	ENDP
HTINST_TEXT	ENDS
END
