/*
**  Cobol Compiler Library -- Accept functions module
**
**  by Rildo Pragana -- 1992
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	29-oct-91 Code implementation
**	24-dec-91 Separate library for files
**	27-apr-92 Separate file for accept functions 
**		(except 'accept from inkey')
**	07-mai-92 Input to accept buffer
*/

#include "mcoblib.h"
#define ALARMES(s) liga_alarmes(TID,s)
char proc_accept( char,byte );
void msetpos( byte * );
void mgetpos( byte * );
void liga_alarmes( byte,char * ) ;

int accept_time( buffer )
char *buffer;
{
	struct tm *timep;
	time_t timel;
	char s[7];
	time(&timel);
	timep = localtime( &timel );
	sprintf(s,"%02d%02d%02d",timep->tm_hour,timep->tm_min,timep->tm_sec);
	move_bytes(buffer,s,6);
	return 0;
}

int accept_date( buffer )
char *buffer;
{
	struct tm *timep;
	time_t timel;
	char s[7];
	time(&timel);
	timep = localtime( &timel );
	sprintf(s,"%02d%02d%02d",(timep->tm_year)%100,
		timep->tm_mon+1,timep->tm_mday);
	move_bytes(buffer,s,6);
	return 0;
}

/* end of MCADT.C */
