/*
**  Cobol Compiler Library -- File Handling Module
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	29-oct-91 Code implementation
**	24-dec-91 Separate library for files
**
*/

#include "mcoblib.h"
#include "math.h"

#define min(x,y) ((x)<(y) ? (x) : (y))
extern char current_dir[];

int mc_close( f
#ifdef MICROBASE
	,v	/* required for MICROBASE format */
#endif
	)
struct file_desc *f;
#ifdef MICROBASE
struct var_fd *v;
#endif
{
#ifdef MICROBASE
	long fill;
	char *buf;
	int i;
#endif
	if (!(--(f->users))) {		/* last user, please close it */
#ifdef MICROBASE
		fill = 1024 - _filelength(f->handle) % 1024;
		buf=RECORD;
		for (i=0;i<f->reclen;i++)
			 *buf++ = -i;
		while (fill) {
			if (fill>f->reclen) {
				_write(f->handle,RECORD,f->reclen);
				fill -= f->reclen;
			}
			else {
				_write(f->handle,RECORD,(unsigned)fill);
				fill = 0;
			}
		}
#endif
/*		if (f->organization==4)
			_write(f->handle,"\x1a",1);*/
		_close(f->handle);
		f->handle=0;
		if (f->organization==1)
			close_index(&(f->index));
	}
	else { /* commit data file */
/*		if (f->organization==4)
			_write(f->handle,"\x1a",1);*/
		mc_commit(f->handle);
	}
	return 0;
}
