/*
**  Cobol Compiler Library -- File Handling Module
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	29-oct-91 Code implementation
**	24-dec-91 Separate library for files
**
*/

#include "mcoblib.h"
#include "math.h"

extern char current_dir[];

int sortnumber=1;
char *sortdesc=NULL;

int keycmp( s1,s2 )
char *s1;
char *s2;
{
	if (sortdesc==NULL)
		return strcmp( s1,s2 );
	else {
		unsigned char i;
		unsigned char direction;
		char *sd;
		sd=sortdesc;
		while (direction=*sd++) {
			for (i=0;i<*sd;i++) {
				if (*s1 < *s2) {
					if (direction==1) return -1;
					else return 1;
				}
				if (*s1++ > *s2++) {
					if (direction==1) return 1;
					else return -1;
				}
			}
			sd++;
		}
		return 0;
	}
}
