/*
**  Cobol Compiler Library -- File Handling Module
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	29-oct-91 Code implementation
**	24-dec-91 Separate library for files
**
*/

#include "mcoblib.h"
#include "math.h"

#define min(x,y) ((x)<(y) ? (x) : (y))
#define PRN_HANDLE *((int *)&(v->filepos))

extern char current_dir[];
extern int sortnumber;
extern char *sortdesc;

int sort_open( f,v )
struct file_desc *f;
struct var_fd *v;
{
	char fname[64];
	char snum[6];
	sprintf(snum,"%05d",sortnumber++);
	strcpy( fname,current_dir );
	strcat( fname,"srt" );
	strcat( fname,snum );
	strcat( fname,".$$d" );
	v->filepos=0;
	v->releasing=1;
	if ((f->handle)>0) return 30;	/* um de cada vez */
	if ((f->handle = _creat( fname,0))==-1) return 30;
	strcpy( fname,current_dir );
	strcat( fname,"srt" );
	strcat( fname,snum );
	strcat( fname,".$$i" );
	make_index(fname,&(f->index),1);
}
