/*
**  Cobol Compiler Library -- File Handling Module
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	29-oct-91 Code implementation
**	24-dec-91 Separate library for files
**
*/

#include "mcoblib.h"
#include "math.h"

#define min(x,y) ((x)<(y) ? (x) : (y))
#define PRN_HANDLE *((int *)&(v->filepos))

extern char current_dir[];

int mc_start_from( f,v,buf )
struct file_desc *f;
struct var_fd *v;
char *buf;
{
    check_open(f);
    if (f->organization==1) {
        move_bytes( v->e.key,buf,f->ixd_desc->len );
        /***** OBS: buf nao e' o registro inteiro, somente a chave *****/
		*(v->e.key + f->ixd_desc->len)=0;
		if (locate_key( &(v->e),&(f->index))==EOIX) {
			v->filepos = -1;
			return 23;
		}
		else
			v->filepos = v->e.recptr;
  }
  /* a seguir, le apenas a chave (actually set) */
  if (_lseek(f->handle,v->e.recptr+f->rec_index,SEEK_SET)==-1L)
        return 21;
  if (_read( f->handle, buf, f->ixd_desc->len )==-1)
        return 30;
  return 0;
}
