/*
**      Biblioteca MCobol -- rotina SENDKEYS
**      Envia caracteres para a console, simulando teclas
**
**      Parametros: MSG -- campo com a sequencia de caracteres
**                  CNT -- campo numerico de 2 posicoes
**                         com o tamanho da sequencia
**
*/
#include <stdio.h>
#include <string.h>
#include <dos.h>

#include <mtnet.h>
#include <task.h>

static SEMAF sdkeys={0,NULL};
static SEMAF waitkeys={0,NULL};
static unsigned char sending_keys=0;
static char msg_return[2]="\r";

void SENDKEYS( msg,cnt ) 
char *msg;
char *cnt;
{
	int nchars;
        nchars = (*cnt - '0') * 10 + ( *( cnt+1 ) - '0');
        set_sdkeys_int( nchars,msg );
	wait( &waitkeys );
}

void SENDRETURN( ) {
        set_sdkeys_int( 1,msg_return );
        wait( &waitkeys );
}

void SENDOPEN( ) {
	while (sending_keys)
                wait(&sdkeys);
        sending_keys=1;
}

void SENDCLOSE( ) {
        sending_keys=0;
        _signal(&sdkeys);
}

void keys_sent( )
{
	_signal( &waitkeys );
}

/* end of SENDKEYS.C */
