;
;  Rotina auxiliar para processamento de interrupcoes
;
;  8-25-92 -- salvando regs es,di,si @ label 'wdev3'
;
extrn     _ticks_delay:far

SPLA_TEXT segment   byte public 'CODE'
DGROUP    group     _DATA,_BSS
     assume    cs:SPLA_TEXT,ds:DGROUP
SPLA_TEXT ends

_DATA     segment word public 'DATA'
d@   label     byte
d@w  label     word
_DATA     ends

_BSS segment word public 'BSS'
b@   label     byte
b@w  label     word
_BSS ends

SPLA_TEXT segment byte public 'CODE'
     assume    cs:SPLA_TEXT,ds:DGROUP

RHword    label     word
ReqHdr    db   22 dup (?)

DevPtrW   label     word
DevPtr    dd   ?

RDLY equ  1         ; retardo entre tentativas
ERRTICKS  equ  5    ; retardo apos erro (output)
NTRY equ  2        ; numero de tentativas antes de 'ticks_wait'
RTRY equ  30        ; numero de retries

call_dev  proc far
     assume    ds:nothing
     push es
     mov  cs:[ReqHdr+2],bl
     mov  word ptr cs:[ReqHdr+3],0
     mov  word ptr cs:[ReqHdr+12h],1
     mov  ax,cs
     mov  es,ax
     mov  bx,offset cs:ReqHdr
     mov  ax,ds
     mov  cs:[DevPtrW+2],ax
     mov  ax,[si+6]
     mov  cs:[DevPtrW],ax
     call dword ptr cs:[DevPtr]    ; call strategy routine
     mov  ax,[si+8]
     mov  cs:[DevPtrW],ax
     call dword ptr cs:[DevPtr]    ; call interrupt routine
     pop  es
     ret
call_dev  endp

     public    _write_device
;
; ********   retorna (AX) -1 se erro ou 0 se OK
;
_write_device  proc far
     ARG  dev:dword,buf:dword,cnt:word
     push bp
     mov  bp,sp
     push es
     push di
     push ds
     push si
     lds  si,[dev]  ; device header pointer in DS:SI
     les  di,[buf]
;
;    jmp  wdev1          ; ***** ENVIA IMEDIATAMENTE *****
wdev5:
     mov  al,RTRY
wdev6:
     mov  ah,NTRY
wdev2:
     mov  word ptr cs:[ReqHdr],0dh ; request header length
     mov  bl,0ah         ; output status cmd
     push ax
     call far ptr call_dev
;
     mov  ax,word ptr cs:[ReqHdr+3]
     and  ax,08300h
     cmp  ax,00100h
     pop  ax
;     test word ptr cs:[ReqHdr+3],8200h  ; 'error' or 'busy'
     jz   wdev1
     dec  ah
     jnz  wdev2
;
wdev3:
     push ax        ; retry counter
     push es
     push di
     push si
     push ds        ; save device header ptr
     mov  ax,DGROUP
     mov  ds,ax
     mov  ax,RDLY        ; delay de n ticks
     push ax
     call far ptr _ticks_delay
     pop  ax
     pop  ds
     pop  si
     pop  di
     pop  es
     pop  ax        ; retry counter
     dec  al
     jnz  wdev6
     mov  ax,-1
     jmp  retr
;
wdev1:    mov  ax,es
     mov  word ptr cs:[ReqHdr+10h],ax
     mov  word ptr cs:[ReqHdr+0eh],di
;
     mov  word ptr cs:[ReqHdr+12h],1    ; No. of bytes to transfer
;    mov  ax,[cnt]
;    mov  word ptr cs:[ReqHdr+12h],ax
;
     mov  word ptr cs:[ReqHdr],16h ; request header length
     mov  bl,8                ; output command
     call far ptr call_dev
;
     test word ptr cs:[ReqHdr+3],8000h  ; error ?
     jz   wdev8
     push es
     push di
     push si
     push ds        ; save device header ptr
     mov  ax,DGROUP
     mov  ds,ax
     mov  ax,ERRTICKS
     push ax
     call far ptr _ticks_delay
     pop  ax
     pop  ds
     pop  si
     pop  di
     pop  es
     jmp  wdev1          ; tenta enviar novamente
;
;    test word ptr cs:[ReqHdr+3],8200h  ; error or busy status ?
;    jz      wdev9
;    jmp  wdev5
wdev8:
     inc  di
     dec  [cnt]
     jnz  wdev55
wdev9:
     xor  ax,ax
;
retr:     pop  si
     pop  ds
     pop  di
     pop  es
     pop  bp
     ret
wdev55:   jmp  wdev5
_write_device  endp

SPLA_TEXT ends
     end
