/*
**  	Multitasker Header file
*/

struct registers {
	unsigned int cs,ip,bx,cx,dx,bp,ds,es,ss,sp,si,di;
};

struct process_type {
	char *name;			/* ptr p/nome do processo */
	char termid;			/* endereco do mt100 */
	struct registers context[1];	/* area p/salvar o contexto */
	struct process_type *next;	/* link p/proximo da fila */
	unsigned int base;		/* init value for bp */
};
typedef struct process_type PROCESS;

typedef struct {
	int val;			/* valor do semaforo */
	PROCESS *p;			/* fila de processos em wait */
} SEMAF;

void wait( SEMAF * );
int _signal( SEMAF * );
void ticks_delay( unsigned int );

void start_task( );

#define ALARMES(s) liga_alarmes( s )
extern void *syslist[];

#ifdef XT_CPU
#define TID running->termid
extern SEMAF dummy_semaf;
#define DUMMY_SEMAF &dummy_semaf
#else
#define TID (((struct process_type *)(*(void **)(*((void **)syslist+1))))->termid)
#define DUMMY_SEMAF (((SEMAF *)(*((void **)syslist+7))))
#endif
/*
**	Estrutura devolvida por Int2F  AH=0xef   AL=0x04
**
** extern void *syslist[];
*/
