#include "stdio.h"
#include "stdlib.h"
#include "math.h"

double exp10[5] = {1e0,1e1,1e2,1e3,1e4};
double ints[] = {1.,2.,3.,4.,5.,6.,7.,8.,9.,10.};
double bins[] = {1.,-1.,2.,-2.,3.,-3.,0.5,-0.5,0.25,-0.25};

void explode_dbl( d )
double d;
{
	int e,sign;
	unsigned int man[4];
	unsigned int *p;
	p = (unsigned *)&d + 3;
	e = ((*p & 0x7ff0) >> 4) - 0x400;
	if (*p & 0x8000) 
		sign = 1;
	else
		sign = 0;
	man[0] = *p-- & 0x0f | 0x10;
	man[1] = *p--;
	man[2] = *p--;
	man[3] = *p;
	printf("\nNumero convertido:\nmantissa = %04x%04x%04x%04x\n",
		man[0],man[1],man[2],man[3]);
	printf("exp = %04x, sign = %d\n",e,sign);
}

void main() {
	printf("\nTeste");
	explode_dbl(5.);
	explode_dbl(2.);
	explode_dbl(1.);
	explode_dbl(0.5);
}
