/*
**      Rotinas de comunicao com processo TSR
**      Micro Cobol Runtime Library
**
**      Rildo Pragana -- 08/92
**
*/
#include <stdio.h>
#include <dos.h>

#include "mtnet.h"
#include "task.h"
#include "mccntrl.h"

void *wait_tsr_msg();
void end_tsr();
void TSRPROC( char * );

/*
**      TSRWAIT e' uma rotina chamada pelo processo "dummy"
**      para receber a proxima mensagem do programa externo.
**      A mensagem e' na forma de um buffer (ponteiro) que pode
**      ser lido ou escrito.
**      Uma vez sincronizada, e' chamada a subrotina
**      com o nome pre-determinado TSRPROC, para processar as
**      transferencias necessarias, recebendo os dois ponteiros
**      para o buffer residente e externo.  No final e' sinalizado
**      o processo externo, indicando o final da operacao.
*/
void TSRWAIT( )
{
        char *EXTBUF;
        EXTBUF = (char *)wait_tsr_msg();
	TSRPROC( EXTBUF );
        end_tsr();
}

void TSROPEN( ) {
        set_2fint();
}

void TSRCLOSE( ) {
        res_2fint();
}

/* end of TSRSEND.C */
