clauses
	escolhe_terminal( OldTerm ) :-
		repeat,
		longmenu(4,15,20,43,43,
			["HT 00","HT 01","HT 02","HT 03","HT 04","HT 05",
			 "HT 06","HT 07","HT 08","HT 09","HT 10","HT 11",
			 "HT 12","HT 13","HT 14","HT 15","HT 16","HT 17",
			 "HT 18","HT 19","HT 20","HT 21","HT 22","HT 23",
			 "HT 24","HT 25","HT 26","HT 27","HT 28","HT 29",
			 "HT 30","HT 31","CONSOLE","PROC 33","PROC 34",
			 "PROC 35","PROC 36"],"Terminal",OldTerm,Sel),
		Sel > 0, Sel1 = Sel - 1, 
		retractall(term_process(_)),
		assert(term_process(Sel1)), !.
	
	atualiza :-
		v(_,_,_,_,_), /* garante que o Mdulo foi carregado */
		v_displ( Vars ),
		shiftwindow(Old),shiftwindow(1),
		display_var_list( Vars ),
		shiftwindow(Old),
		findline(Lin),
		goto_line(Lin), !.
	atualiza :- 
		/*shiftwindow(OldW),
		makewindow(3,9,32,"ERRO",5,20,3,40),
		write("o Mdulo deve ser carregado primeiro!"),
		readchar(_), removewindow, shiftwindow(OldW), */
		!.
		
	load_source( Fn ) :-	
		newext( Fn,"cob",Fn1 ),
		existfile(Fn1),
		read_source( Fn1 ), fail.
	load_source( Fn ) :-		
		newext( Fn,"dbv",Fn2 ),
		existfile(Fn2),
		retractall(_,select_table),
		consult(Fn2,select_table), !.
	load_source( _ ) :- !.
		
	intl_strl( [],[] ) :- !.
	intl_strl( [HI|TI],[HS|TS] ) :-
		str_int(HS,HI), !,
		intl_strl(TI,TS).
		
	clr_all_breakpoints :-
		current_ip( CS,_ ),
		list_breakpt( L ),
		for_each( Bkp,L ),
		l(Bkp,IP,_,_,_), 
		clr_breakpt( CS,IP ), fail.
	clr_all_breakpoints.
	
	escolha_janela( J ) :-
		longmenu(4,55,12,43,43,["Vista","Listagem"],
			"Janela a Modificar",1,J), !.

	pdwaction(1,0) :-	/* Mdulo */
		readfilename(10,10,6,6,"dbg","",Fn),
		retractall(_,symb_table),assert(var_selected(1)),
		assert(v_displ([])),assert(vars([])),assert(console_txt("",0,0)),
		assert(proc_ptr(0,0)),assert(term_process(0)),
		savestatus(OLDSTAT),
		changestatus("Aguarde... Lendo definio de variveis"),
		read_symb_table(Fn),
		changestatus("Atualizando variaveis"),
		retract(vars(_)), findall(N,v(N,_,_,_,_),Vars),
		sort(Vars,VarsSorted),
		assert(vars(VarsSorted)),
		load_source( Fn ),
		changestatus(OLDSTAT),
		retractall(initializing), !.

	pdwaction(2,0):-	/* Terminal */
		term_process(OldT), OldTerm = OldT + 1,
		escolhe_terminal( OldTerm ),
		proc_ptr(Seg,Off),
		calc_base_addr(Seg,Off),!,atualiza.

	pdwaction(3,1):-	/* troca Diretrio */
		setdir(10,30,9,9),!.

	pdwaction(3,2):- 	/* Memria */
		storage(_,Heap,_), 
		makewindow(3,9,32,"Status da memria",5,20,3,50),
		write("Memria disponvel: ",Heap, " bytes"),
		readchar(_), removewindow, 
		!. 

	pdwaction(3,3):-	/* Shell */
		system(""),
		!.

	pdwaction(3,4) :- 	/* Posiciona fonte */
		assert(initializing),
		lineinput(5,10,40,9,32,"Vai para linha: ","",LineStr),
		str_int( LineStr,Lin ),
		goto_line( Lin ), 
		readchar(_), retract(initializing), !.
				
	pdwaction(3,5) :-	/* Lista fonte */
		findline( Lin ),
		display_line( Lin ), !.

	pdwaction(3,6) :-	/* set Breakpoint */
		lineinput(5,10,40,9,32,"Breakpoint na linha: ","",LineStr),
		str_int( LineStr,Lin ),
		l(Lin,IP,_,_,_), current_ip( CS,_ ),
		breakpt( CS,IP,Lin ), !.
		
	pdwaction(3,7) :-	/* Apaga breakpoint */
		lineinput(5,10,40,9,32,"Linha do breakpoint: ","",LineStr),
		str_int( LineStr,Lin ),
		l(Lin,IP,_,_,_), current_ip( CS,_ ),
		clr_breakpt( CS,IP ), !.
	
	pdwaction(3,8) :-	/* mostra breaKpoints */
		list_breakpt( LB ),
		intl_strl( LB,L ),
		listlen( L,NOOFROW ),
		not(NOOFROW=0),
		NOOFCOL = 5,
		adjframe(32,NOOFROW,NOOFCOL,HH1,HH2),
		adjustwindow(5,20,HH1,HH2,AROW,ACOL),
		makewindow(3,9,32,"Lista",AROW,ACOL,HH1,HH2),
		writelist(0,NOOFCOL,L),
		readchar(_), removewindow, !.
		
	pdwaction(3,9) :-	/* Continua execuo */
		restart, !.
		
	pdwaction(4,0):-  	/* Atualiza */
		atualiza,!.
		
	pdwaction(5,1):-	/* Adiciona na lista */
		v_displ(Vars),listlen(Vars,Len),Len<19,
		select_var( SymName ),
		retract(v_displ(_)), Vars1 = [SymName|Vars],
		assert(v_displ(Vars1)), atualiza, !.
	pdwaction(5,2):-	/* Retira da lista */
		v_displ( Vars ),
		conv_index( Vars, VarsN ),
		longmenu(4,55,12,43,43,VarsN,"Lista (VIEW)",1,Sel),
		Sel1=Sel-1, index( Sel1,Vars,SymName ),
		delete( Vars,SymName,Vars1 ),
		retract(v_displ(_)), assert(v_displ(Vars1)), atualiza, !.
	pdwaction(5,3):-	/* Modifica valor */
		v_displ( Vars ),
		conv_index( Vars,VarsN ),
		longmenu(4,55,12,43,43,VarsN,"Lista (VIEW)",1,Sel),
		Sel1=Sel-1, index( Sel1,Vars,SymName ),
		modify( SymName ), atualiza, !.
	pdwaction(5,4):-	/* Obtm vista */
		readfilename(4,5,6,6,"dbv","",Fn),
		retract(_,select_table),
		consult(Fn,select_table), atualiza, !.
	pdwaction(5,5):-	/* Salva vista */
		readfilename(4,5,6,6,"dbv","",Fn),
		save(Fn,select_table),
		!.
	pdwaction(5,6) :-	/* Lista pargrafos e seces */
		makewindow(3,9,32,"Pargrafos e seces",3,1,20,78),
		lbl( Label,Addr ),
		writef("%s = %04x   ",Label,Addr), fail.
	pdwaction(5,6) :-
		readchar(_), removewindow, !.
	pdwaction(5,7) :-	/* Lista numeros de linha */
		makewindow(3,9,32,"Nmeros de linha",3,1,20,78),
		l( Lin,Addr,Label,_,Kind ),
		writef("<%d> %04x %s %d  ",Lin,Addr,Label,Kind), fail.
	pdwaction(5,7) :-
		readchar(_), removewindow, !.
	pdwaction(5,8) :-
		shiftwindow(OldW), shiftwindow(1),
		list_variables, readchar(_),
		shiftwindow(OldW), !.

	pdwaction(6,0):-	/* Console */
		console_txt( S,Y,X ),
		makewindow(60,15,0,"",0,0,25,80),
		window_str( S ),
		cursor( Y,X ),
		console,
		get_cursor( NewY,NewX ),
		retract( console_txt(_,_,_) ), window_str( NewS ), 
		assert( console_txt( NewS,NewY,NewX ) ),
		removewindow, 
		atualiza, !.

	pdwaction(7,1) :- 	/* cores Texto */
		escolha_janela(J), J>0,
		shiftwindow(OldW), shiftwindow(J),
		colorsetup(0), shiftwindow(OldW), 
		!.
	pdwaction(7,2) :- 	/* cores Borda */
		escolha_janela(J), J>0,
		shiftwindow(OldW), shiftwindow(J),
		colorsetup(1), 
		makewindow(_,W1_attr1,W1_attr2,_,W1_IL,W1_IC,W1_Hei,W1_Wid),
		retractall( window_setup(J,_,_,_,_,_,_),setup_db),
		assert( window_setup(J,W1_attr1,W1_attr2,W1_IL,W1_IC,W1_Hei,W1_Wid) ),
		shiftwindow(OldW), 
		!.
	pdwaction(7,3) :-	/* tamanho e Posio */
		escolha_janela(J), J>0,
		shiftwindow(OldW), shiftwindow(J),
		resizewindow, 
		makewindow(_,W1_attr1,W1_attr2,_,W1_IL,W1_IC,W1_Hei,W1_Wid),
		retractall( window_setup(J,_,_,_,_,_,_),setup_db),
		assert( window_setup(J,W1_attr1,W1_attr2,W1_IL,W1_IC,W1_Hei,W1_Wid) ),
		shiftwindow(OldW), 
		!.
	pdwaction(7,4) :-
		save("setupdbg.mcd",setup_db), !.
	
	pdwaction(8,0) :-
		btndx(Index),
		bt_close(dba,Index),
		db_close(dba),
		existfile("mcdebug.bin"),
		db_delete("mcdebug.bin",in_file), fail.
	pdwaction(8,0):-	/* Fim */
		clr_all_breakpoints,
		install_trap(0),
		removewindow, removewindow(1,1), removewindow(2,1), 
		removewindow(60,1),
		write("\n"),
		write("\n    Obrigado por usar o MCobol Debugger Vers. 1.2     "),
		write("\n   Quaisquer sugestoes pelo telefone (081)459-1097    "),
		write("\n    ou pela Caixa Postal 7440 Recife Pernambuco       "),
		write("\n\n\n"),
		exit,!.

	pdwaction(_,_):-!.

	get_window_setup( N,Attr1,Attr2,IL,IC,Wid,Hei ) :-
		existfile("setupdbg.mcd"),
		consult("setupdbg.mcd",setup_db),
		window_setup( N,Attr1,Attr2,IL,IC,Wid,Hei ), !.
	get_window_setup( 1,7,30,3,0,15,80 ).
	get_window_setup( 2,48,14,18,0,6,80 ).
	/*get_window_setup( 3,7,20,5,20,3,50 ).
	get_window_setup( 4,7,20,5,20,3,50 ).*/
		
goal
	db_create(dba,"mcdebug.bin",in_file),
	bt_create(dba,"ndx",Index,5,4),
	clearwindow,
	get_window_setup( 1,W1_attr1,W1_attr2,W1_IL,W1_IC,W1_Hei,W1_Wid ),
	makewindow(1,W1_attr1,W1_attr2,"Percontrol - P.O. Box 7440 Recife Brazil -- MCobol Debugger ",W1_IL,W1_IC,W1_Hei,W1_Wid),
	get_window_setup( 2,W2_attr1,W2_attr2,W2_IL,W2_IC,W2_Hei,W2_Wid ),
	makewindow(2,W2_attr1,W2_attr2,"Listagem do programa MCobol (.COB) -- (C) 1992 Percontrol",W2_IL,W2_IC,W2_Hei,W2_Wid),
	makestatus(112,""),
	retractall(_),
	assert(initializing),
	assert(btndx(Index)),
	check_installed,
	shiftwindow(1),
	install_trap(1),
	repeat,
/*        1         2         3         4         5         6         7
01234567890123456789012345678901234567890123456789012345678901234567890123456789
   Mdulo  Terminal  Utilitrios  Atualiza  Variaveis  Console  Janelas  Fim 
*/
	changestatus("Escolha usando a letra destacada ou com as setas [ \024\025\027\026 ] e batendo <Enter>."),
	pulldown(96,
		[ curtain(3,"Mdulo",[]),
		  curtain(11,"Terminal",[]),
		  curtain(21,"Utilitarios",["troca Diretrio","Memria",
		  	"Shell (command)","Posiciona fonte","Lista fonte",
		  	"set Breakpoint","Apaga breakpoint",
		  	"mostra breaKpoints","Continua execuo"]),
		  curtain(34,"Atualiza",[]),
		  curtain(44,"Variaveis",["Adiciona na lista","Retira da lista",
		  	"Modifica valor","Obtm vista","Salva vista",
		  	"Lista pargrafos e seces","Nmeros de linha",
		  	"lista Variveis"]),
		  curtain(55,"Console",[]),
		  curtain(64,"Janelas",["cores Texto","cores Borda","tamanho e Posio",
		  		"Salva setup"]),
		  curtain(73,"Fim",[])
		], _, _),
	fail,!.
