/*
**      Interface to Microsoft Cobol using TSR Multiplex Interrupt (2F)
*/

#define TESTETSR 1

/*
** Estrutura para comunicacao com processo externo
*/

struct comm {
	char comando;
	char *codigo;
	char *nome;
	char *status;
	char *preco;
};

#include "stdio.h"
#include "dos.h"

void SENDTSR( void * );

void SENDTSR( BUFFER )
struct comm *BUFFER;
{
        union REGS iregs,oregs;
        struct SREGS sregs;
	/******** envia a msg ate ser bem sucedido **********/
	do {
		iregs.x.ax = 0xef81;
		iregs.x.dx = FP_OFF(BUFFER);
		sregs.es = FP_SEG(BUFFER);
		int86x( 0x2f,&iregs,&oregs,&sregs );
	} while (oregs.h.al == 0 );
	/****** espera final da operacao do programa residente ********/
	do {
		iregs.x.ax = 0xef82;
		int86( 0x2f,&iregs,&oregs );
	} while (oregs.h.al == 0);
}

#ifdef TESTETSR
char codigo[7];
char nome[41];
char status[30];
char preco[13];
struct comm sc;

void main() {
	int i;
	int c;
	sc.codigo = codigo;
	sc.nome = nome;
	sc.preco = preco;
	sc.status = status;
  while(1) {
	printf("\nComando (A)ltera preco, (M)ostra produto: ");
	c=getch();
	if (c=='M') {
		printf("\nChave:");
		gets(codigo);
		if (*(codigo)==0) break;
		sc.comando = 'M';
		SENDTSR(&sc);
		printf("\nProduto: [%s]\n",nome);
	}
	else if (c=='A') {
		printf("\nCodigo:");
		gets(codigo);
		if (*(codigo)==0) break;
		printf("\nNovo preco:");
		gets(preco);
		if (*(preco)==0) break;
		sc.comando = 'A';
		SENDTSR(&sc);
		printf("\nStatus: [%s]\n",status);
	}
	else {
		printf("\nComando Invalido!");
	}
  }
}
#endif
/* end of TSRCALL.C */
