/*	Getargs.h	Typedefs and defines
*/

#define INTEGER 0
#define BOOLEAN 1
#define CHARACTER 2
#define STRING 3
#define PROC 4

typedef struct {
	unsigned arg: 7; /* command line switch */
	unsigned type: 4; /* variable type */
	int *variable; /* pointer to variable */
	char *errmsg; /* pointer to error message */
} ARG;
