/*
**  Cobol Compiler Library -- General Utility Module
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	29-oct-91 Code implementation
**	24-dec-91 Separate library for files
**
*/

/*void *htalloc();*/
void *whstk();
void *get_syslist();
#include "htcoblib.h"
#include "getargs.h"
#define TID (((struct process_type *)(*(void **)(*((void **)syslist+1))))->termid)

#define min(x,y) ((x)<(y) ? (x) : (y))

extern unsigned int htmem;
int alocpar = 0;
unsigned int convmem = 0;
#define ARGTABSIZE (sizeof(Argtab)/sizeof(ARG))
static ARG Argtab[] = {
/* 		Tabela de argumentos de mtnet_init			*/
/* 	switch	tipo	variavel	msg				*/
	{ 'a',	INTEGER, &alocpar,
		"paragrafos de memoria (16 bytes) reservadas"},
	{ 'c',  BOOLEAN, &convmem,
		"seleciona memoria convencional"}
};

int lib_debug = 0; /* =1 for debugging  */
struct task_table {
	void (*function)();
	int stack_words;
	char name[9];
	char terminal;
    void *stk;
}*init_tbl=NULL;
struct task_table *load_task_table( );
char current_dir[65]="";
void *syslist;

#define ALARMES(s) liga_alarmes(s)

char loc_handles[100];

void alloc_sft() {
	void **handle_tbl;
	void *old_tbl;
	int *handle_cnt;
	char *s;
	int nfopen;
	nfopen = 100;
	handle_tbl=(void **)MK_FP(_psp,0x34);
	old_tbl=*handle_tbl;
    *handle_tbl = loc_handles;
/*    *handle_tbl = calloc( nfopen,sizeof(byte) );*/
/*    *handle_tbl = htalloc( (nfopen/16) + 1 );*/
	handle_cnt=MK_FP(_psp,0x32);
	set_bytes( *handle_tbl,0xff,nfopen );
	move_bytes( *handle_tbl,old_tbl,*handle_cnt );
	*handle_cnt = nfopen;
	s = (byte *)old_tbl;
/*	printf("\nold_tbl = %04x:%04x",FP_SEG(old_tbl),FP_OFF(old_tbl));
	printf("\n%02x %02x %02x %02x %02x %02x %02x",
		*s,*(s+1),*(s+2),*(s+3),*(s+4),*(s+5),*(s+6));
	printf("\nNew SFT = %04x:%04x",
		FP_SEG(*handle_tbl),FP_OFF(*handle_tbl));
	s = (byte *)(*handle_tbl);
	printf("\n%02x %02x %02x %02x %02x %02x %02x",
		*s,*(s+1),*(s+2),*(s+3),*(s+4),*(s+5),*(s+6));
*/
}

void liga_alarmes ( alarmes )
char *alarmes;
{
unsigned char term=TID;
unsigned int p=1;
int t,al=0;
	if (term>=32) return;
	for ( t=0 ; t<=5 ; t++ ) {
		if ( alarmes[t] == 'L')
			al = al | p;
		else if ( alarmes[t] == 'D' )
			al = al & ~p;
		else
			break;
		 p=p<<1;
	}
	setleds( al );
}

unsigned int *stk[NUMTERM+5];
unsigned int normoff,normseg;
void *tmp;

static unsigned int alloc_stack()
{
    int i;
    unsigned int stacklen;
    for (i=0;i<NUMTERM+5;i++)
		if ((init_tbl+i)->stack_words) {
            stk[i]=(init_tbl+i)->stk;
/*            stacklen = (unsigned int)((init_tbl+i)->stack_words) << 1;
            stk[i] = (unsigned int *)malloc(stacklen);*/
/*            stk[i] = (unsigned int *)htalloc(stacklen/16 + 1);*/
/*            stk[i] = (unsigned int *)calloc((unsigned int)
                ((init_tbl+i)->stack_words),sizeof(unsigned int));*/
/*printf("\nAlloc:stacklen=%d,term=%d,stk=%04x:%04x,",
        (init_tbl+i)->stack_words << 1,
        (init_tbl+i)->terminal,
        FP_SEG( stk[i]), FP_OFF(stk[i]) );
*/
            /* normaliza o ponteiro obtido */
            normoff = FP_OFF(stk[i]) & 0x0f;
            normseg = ((FP_OFF(stk[i])) >> 4) + FP_SEG(stk[i]);
            *((unsigned *)(stk+i)) = normoff;
            *(((unsigned *)(stk+i))+1) = normseg;
/*printf("\nnormpt=%04x:%04x",
        normseg,normoff );
getch();*/
/*
printf("\nAlloc:stacklen=%d,term=%d,i=%d,stk=%04x:%04x,func=%04x:%04x",
        (init_tbl+i)->stack_words << 1,
        (init_tbl+i)->terminal,i,
        FP_SEG(stk[i]),FP_OFF(stk[i]),
        FP_SEG((init_tbl+i)->function),
        FP_OFF((init_tbl+i)->function) );
getch();
*/
            if (stk[i]==NULL) {
                printf("\nEstouro de memoria, Terminal %1.",i);
                (init_tbl+i)->stack_words = 0;
            }
        }
    tmp = malloc(1);
    free(tmp);
    printf("\n_psp = %04x",_psp);
	printf("\nlast memory used = %04x:%04x",FP_SEG(tmp),FP_OFF(tmp));
getch();
/*
    for (i=0;i<NUMTERM+5;i++) {
        if ((init_tbl+i)->stack_words)
            free(stk[i]);
    }
*/
            /* normaliza o ponteiro obtido */
            normoff = FP_OFF(tmp) & 0x0f;
            normseg = ((FP_OFF(tmp)) >> 4) + FP_SEG(stk[i]);
            *((unsigned *)(tmp)) = normoff;
            *(((unsigned *)(tmp))+1) = normseg;
    return (unsigned int)((((unsigned long)(FP_SEG(tmp)) * 16L +
        (unsigned long)(FP_OFF(tmp)) -
        (unsigned long)_psp * 16L)/1024L)+1L);
}

static void inicia_processos( )
{
	int i,stacklen;
	int name_printed=0;
	for (i=0;i<NUMTERM+5;i++)
        if ((init_tbl+i)->stack_words) {
            if (!name_printed) {
				name_printed++;
				printf("\nAplicao <%8.8s>, HandTerm #%d",
					init_tbl->name,i);
			}
            else {
				printf(",%d",i);
            }
            stacklen = (init_tbl+i)->stack_words << 1;

printf("\nCreate: %d,%d,%04x:%04x,%04x:%04x,%04x.",
    (init_tbl+i)->terminal,stacklen,FP_SEG(stk[i]),FP_OFF(stk[i]),
    FP_SEG((init_tbl+i)->function),FP_OFF((init_tbl+i)->function),
    get_ds());
getch();

            create_task( (init_tbl+i)->terminal,
                stacklen,FP_OFF(stk[i]),FP_SEG(stk[i]),
				(init_tbl+i)->function, get_ds() );
		}
/*        init_spooler();*/
        printf("\n");
}

struct mcb {
	unsigned char typ;
    unsigned int owner;
    unsigned int size;
    unsigned char rsv1;
    unsigned char rsv2;
    unsigned char rsv3;
    unsigned char name[8];
} far *mcbp;
unsigned far *mcbseg;
struct mcb *mcb_psp;

union REGS reg,oreg;
struct SREGS segr;

void main( argc,argv )
int argc;
char **argv;
{
/*	void *tmp;*/
	unsigned int size;
    char name[10];
    name[8]=0;
    getargs( argc,argv,Argtab,ARGTABSIZE );
	printf("\n\n*** Rede de Microterminais HandTerm (MR) ***");
	printf("\nHandTerm Tecnologia -- 1993");
    if ((syslist=get_syslist())==NULL) {
        printf("\n\nHTDRV no encontrado!\n");
		exit(1);
	}
	get_srv_entry();
    if (check_installed() != 0) {
        printf("\n\nAplicao j instalada!\n");
		exit(2);
	}
/*
    printf("\nsyslist=%04x:%04x",FP_SEG(syslist),FP_OFF(syslist));
    getch();
*/
	_getcwd(current_dir,64);
	strcat(current_dir,"\\");
/*
    printf("\nDiretorio corrente: %s\n",current_dir);
    tmp = (void *)*syslist;
    printf("\nready=%04x:%04x",FP_SEG(tmp),FP_OFF(tmp));
	tmp = (void *)*((void **)syslist+1);
    printf("\nrunning=%04x:%04x",FP_SEG(tmp),FP_OFF(tmp));
*/
	init_tbl=load_task_table();
/*    htallocinit();
printf("\nhtmem = %04x",htmem); getch();*/
    alloc_sft();
/*printf("\nhtmem = %04x",htmem); getch();*/
    size = alloc_stack();
/*printf("\nhtmem = %04x",htmem); getch();*/
    printf("\nSegmento do PSP = 0x%04x, Memria ocupada %d Kbytes.",
		_psp,size);
/*getch();
    printf("\nSet swapping...");
*/
    if (convmem==0)
		size=set_swapping(_psp,size);
	else
		set_swapping(_psp,0);
	/* size agora reflete Kb de mem convencional */
/*getch();
    printf("\nInicia processos...");
*/    inicia_processos();
/*getch();*/
    if (size || convmem) {
        printf("\n\nPrograma alocado na memria convencional.");
        printf("\nSize = %d, Convmem = %d\n",size,convmem);
/*
printf("\nPrograma ficara' residente...");
        reg.h.ah = 0x52;
        _intdosx( &reg,&oreg,&segr );
        mcbseg = MK_FP( segr.es,oreg.x.bx-2 );
        mcbp = MK_FP( *mcbseg,0 );
        while( mcbp->typ == 0x4d ) {
            mcb_psp = MK_FP((mcbp->owner - 1),0);
            if (mcbp->owner == 8)
                memcpy(name,"MsDos",8);
            else if (mcbp->owner)
                memcpy(name,mcb_psp->name,8);
            else
                memcpy(name,"Free",8);
            printf( "\nMCB: %04x:%04x,type=%c,",
                FP_SEG(mcbp),FP_OFF(mcbp),mcbp->typ);
            printf("owner=%04x, size=%04x, name=%s",
                mcbp->owner,mcbp->size,name);
            mcbp = MK_FP( FP_SEG( mcbp ) + mcbp->size + 1 ,
                    FP_OFF( mcbp ) );
        }
            printf( "\nMCB(last): %04x:%04x, type=%c, owner=%04x, size=%04x",
                FP_SEG(mcbp),FP_OFF(mcbp),
                mcbp->typ,mcbp->owner,mcbp->size);
getch();
*/
        keep(size);
	}
}

void stop_run( ) {
	ALARMES("DDD");
	mprintf("\f*** HandTerm ***    OFFLINE");
	while(1) htgetc();
}

void accept_inkey( buffer ) 
char *buffer;
{
	char c,s[4];
	c=0;
	c=inkey_asm();
	sprintf(s,"%03.3d",c);
	move_bytes(buffer,s,3);
}

void runtime_err( ) { }

void init_terminal( ) {
	if (TID>32) return;
	if (TID<32) {
		ALARMES("DLDDD");
        mprintf("\fHandTerm #%02d\nTerminal ativo!",TID);
/*        htgetc();
        tmp = whstk();
        mprintf("\fPilha--> %04x:%04x",FP_SEG(tmp),FP_OFF(tmp));
        htgetc();
*/
	}
    while(htgetc()!=DEL);
}

void display( buffer,len )
char *buffer;
int len;
{ /* anteriormente disp_glob() */
	while (len--)
		htputc(*buffer++);
}

void display_erase() { htputc('\f'); }

void newline() { htputc('\n'); }

/* end of MCLIBDIR.C */

