; 	
;	Functions for HandTerm driver support
;	(C) 1993 R. Pragana 
;
;
	TITLE   htcall

HTCALL_TEXT	SEGMENT  BYTE PUBLIC 'CODE'
HTCALL_TEXT	ENDS

_DATA	SEGMENT  WORD PUBLIC 'DATA'
_DATA	ENDS

_BSS	SEGMENT  WORD PUBLIC 'BSS'
_BSS	ENDS
$$SYMBOLS	SEGMENT  BYTE PUBLIC 'DEBSYM'
$$SYMBOLS	ENDS
$$TYPES	SEGMENT  BYTE PUBLIC 'DEBTYP'
$$TYPES	ENDS
DGROUP	GROUP	_BSS,	_DATA

_DATA	SEGMENT 
        public _htmem
_htmem  dw      0
_DATA   ENDS

	ASSUME  CS: HTCALL_TEXT, DS: DGROUP, SS: DGROUP, ES: DGROUP
HTCALL_TEXT      SEGMENT

        public _whstk
_whstk  proc    far
        mov     dx,ss
        mov     ax,sp
        ret
_whstk  endp

        public  _end_tsr
_end_tsr	proc far
	push	bp
	mov	bp,sp
	mov	ah,10h
	call	dword ptr cs:_server
	pop	bp
	ret
_end_tsr	endp

	public	_wait_tsr_msg
_wait_tsr_msg	proc far
	push	bp
	mov	bp,sp
        push    ds
	push	si
	push	di
        push    cx
	mov	ah,0fh
	call	dword ptr cs:_server
        pop     cx
        pop     di
	pop	si
	pop	ds
	pop	bp
	ret
_wait_tsr_msg	endp

	public _check_installed
_check_installed	proc far
	push	bp
	mov	bp,sp
	mov	ah,0eh
	call	dword ptr cs:_server
	pop	bp
	ret
_check_installed	endp

	public _get_ds
_get_ds proc far
	mov	ax,ds
	ret
_get_ds endp

        public _server
_srvw   label   word
_server dd      0

	public _get_syslist
_get_syslist proc far
	push	bp
	mov	bp,sp
	push	si
	push	ds
        mov     ax,0ef00h
        int     2fh
        and     al,al
        jnz      gsys1
        xor     ax,ax
        mov     dx,ax
        jmp     gsys2
gsys1:  mov     ax,0ef04h
	int	2fh
	mov	dx,ds
	mov	ax,si
gsys2:  pop     ds
	pop	si
	pop	bp
	ret
_get_syslist endp
	
	public _get_srv_entry
_get_srv_entry proc far
	push	bp
	mov	bp,sp
	push	ds
	mov	ax,0ef01h
	int	2fh
	mov	word ptr cs:_srvw,si
	mov	word ptr cs:_srvw+2,ds
	pop	ds
	pop	bp
	ret
_get_srv_entry endp
	
	public _suspend
_suspend proc far
	push	bp
	mov	bp,sp
	mov	bx,word ptr [bp+6]
	mov	ah,05h
	call	dword ptr _server
	pop	bp
	ret
_suspend endp
	
	public _set_swapping
_set_swapping	proc far
	push	bp
	mov	bp,sp
	mov	ax,0b00h
	mov	bx,[bp+6]
	mov	cx,[bp+8]
	call	dword ptr cs:_server
	pop	bp
	ret
_set_swapping	endp

	public _create_task
_create_task proc far
	push	bp
	mov	bp,sp
	push	ds
	push	bx
	push	cx
	push	dx
	push	si
	push	es
	push	di
	push	ax
	mov	bx,word ptr [bp+6]
	mov	cx,word ptr [bp+8]
	mov	dx,word ptr [bp+12]
	mov	si,word ptr [bp+10]
	mov	es,word ptr [bp+16]
	mov	di,word ptr [bp+14]
	mov	ds,word ptr [bp+18]
	mov	ah,8
	call	dword ptr cs:_server
	pop	ax
	pop	di
	pop	es
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ds
	pop	bp
	ret	
_create_task endp

	public _kill_task
_kill_task proc far
	push	bp
	mov	bp,sp
	mov	ah,0ah
	call	dword ptr cs:_server
	pop	bp		; aqui o processo ja nao retorna
	ret	
_kill_task endp
	
	public _htgetc
_htgetc proc far
	push	bp
	mov	bp,sp
	mov	ah,0
	call	dword ptr cs:_server
	pop	bp
	ret	
_htgetc endp

	public	_inkey_asm
_inkey_asm	proc far
	push	bp
	mov	bp,sp
	mov	ah,0dh
	call	dword ptr cs:_server
	pop	bp
	ret	
_inkey_asm	endp

	public _setleds
_setleds proc far
	push	bp
	mov	bp,sp
	push	ax
	push	bx
	mov	bx,word ptr [bp+6]
	mov	ah,4
	call	dword ptr cs:_server
	pop	bx
	pop	ax
	pop	bp
	ret
_setleds endp

	public _goxy
_goxy	proc far
	push	bp
	mov	bp,sp
        mov     bh,byte ptr [bp+8]
        mov     bl,byte ptr [bp+6]
	mov	ah,2
	call	dword ptr cs:_server
	pop	bp
	ret
_goxy	endp

        public _pnewline
_pnewline       proc far
        push    bp
        mov     bp,sp
        mov     ax,word ptr [bp+6]
        neg     al
        sub     al,64
        mov     bh,al
        mov     bl,0dh
        push    bx
        mov     ah,11h
        call    dword ptr cs:_server
        pop     bx
        mov     ax,word ptr [bp+6]
        neg     al
        sub     al,64
        mov     bh,al
        mov     bl,0ah
        push    bx
        mov     ah,11h
        call    dword ptr cs:_server
        pop     bx
        pop     bp
        ret
_pnewline       endp

        public _pputc
_pputc  proc far
        push    bp
	mov	bp,sp
	push	ax
	push	bx
        mov     ax,word ptr [bp+6]
        neg     al
        sub     al,64
        mov     bh,al           ; printer port for term #
        mov     ax,word ptr [bp+8]
        mov     bl,al           ; char to print
        mov     ah,11h
	call	dword ptr cs:_server
	pop	bx
	pop	ax
	pop	bp
        ret     
_pputc  endp

        public _htputc
_htputc proc far
	push	bp
	mov	bp,sp
	push	ax
	push	bx
	mov	bx,word ptr [bp+6]
	mov	ah,1
	call	dword ptr cs:_server
	pop	bx
	pop	ax
	pop	bp
	ret	
_htputc endp
	
	public _htputs
_htputs proc far
	push	bp
	mov	bp,sp
	push	ds
	push	si
	lds	si,dword ptr [bp+6]
htploop:
	mov	bl,byte ptr [si]
	and	bl,bl
	je	htpfim
	xor	bh,bh
	mov	ah,1
	call	dword ptr cs:_server
	inc	si
	jmp	htploop
htpfim:
	pop	si
	pop	ds
	pop	bp
	ret
_htputs endp

	public _htaccept
_htaccept proc far
	push	bp
	mov	bp,sp
	push	ds
	push	es
	push	si
	push	di
	push	bx
	lds	si,dword ptr [bp+6]
	les	di,dword ptr [bp+10]
	mov	bx,word ptr [bp+14]
	mov	ah,9
	call	dword ptr cs:_server
	pop	bx
	pop	di
	pop	si
	pop	es
	pop	ds
	pop	bp
	ret	
_htaccept endp

	public __signal
__signal proc far
	push	bp
	mov	bp,sp
	push	ds
	push	si
	lds	si,[bp+6]
	mov	ah,7
	call	dword ptr cs:_server
	pop	si
	pop	ds
	pop	bp
	ret
__signal endp

	public _wait
_wait 	proc far
	push	bp
	mov	bp,sp
	push	ds
	push	si
	lds	si,[bp+6]
	mov	ah,6
	call	dword ptr cs:_server
	pop	si
	pop	ds
	pop	bp
	ret
_wait	endp

	public _keep
_keep	proc far
	push	bp
	mov	bp,sp
	mov	dx,[bp+6]
	mov	cl,6
	shl	dx,cl
	mov	ax,3100h
	int	21h
	pop	bp	; jamais sera' executado...
_keep	endp

        public _mgetpos
_mgetpos proc far
        push    bp
	mov	bp,sp
        mov     ah,0ch
        call    dword ptr cs:_server
        les     bx,[bp+6]
        mov     byte ptr es:[bx],al
        mov     byte ptr es:[bx+1],ah
        pop     bp
        ret
_mgetpos endp

        public _msetpos
_msetpos proc far
        push    bp
	mov	bp,sp
        les     bx,[bp+6]
        mov     al,byte ptr es:[bx]
        mov     ah,byte ptr es:[bx+1]
        mov     bx,ax
        mov     ah,02
        call    dword ptr cs:_server
        pop     bp
        ret
_msetpos endp

        public  _cript_check
_cript_check proc far
        push    bp
        mov     bp,sp
        mov     ah,12h
        mov     bx,word ptr [bp+6]
        call    dword ptr cs:_server
        pop     bp
        ret
_cript_check endp

        public _dos_alloc
_dos_alloc proc far
        push    bp
        mov     bp,sp
        mov     bx,[bp+6]
        mov     ah,48h
        int     21h
        jnc     allocok
        xor     ax,ax
allocok:
        mov     dx,ax
        xor     ax,ax
        pop     bp
        ret
_dos_alloc endp

        public _dos_free
_dos_free proc far
        push    bp
        mov     bp,sp
        push    es
        mov     ax,[bp+8]       ; segmento para liberar
        mov     es,ax
        mov     ah,49h
        int     21h
        pop     es
        pop     bp
        ret
_dos_free endp

        public _flushkbd
_flushkbd proc far
        push    bp
	mov	bp,sp
        mov     ah,13h
        call    dword ptr cs:_server
        pop     bp
        ret
_flushkbd endp

HTCALL_TEXT     ENDS
END
