/*
**  Cobol Compiler Library -- Math Module
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	29-oct-91 Code implementation
**	24-dec-91 Separate library for files
**
*/

#include "mcoblib.h"
#include <math.h>

#define min(x,y) ((x)<(y) ? (x) : (y))

void fldtod( struct fld_desc *, char *, double * );
extern double fp1;
extern double fp2;
extern double fp3;

/*void dump_double( msg,ptr )
char *msg;
unsigned char *ptr;
{
	int i;
	mprintf(msg);
	ptr+=7;
	for (i=0;i<8;i++)
		mprintf("%02.2x",*ptr--);
	mgetkey();
}*/

int check_condition( f1,s1,f2,s2,f3,s3 )
struct fld_desc *f1;
char *s1;
struct fld_desc *f2;
char *s2;
struct fld_desc *f3;
char *s3;
{
	int i,len2,len3;
	if (f1->type == '9') {
		fldtod(f1,s1,&fp1);
		fldtod(f2,s2,&fp2);
		fldtod(f3,s3,&fp3);
		if (fp1>=fp2 && fp1<=fp3)
			return 0;
		return 1;
	}
	else {
		len2=f2->len;
		len3=f3->len;
		for (i=0;i<f1->len;i++) {
			if (i<len2)
				if (*(s1+i) < *(s2+i)) return 1;
			if (i<len3)
				if (*(s1+i) > *(s3+i)) return 1;
		}
		return 0;
	}
}

/* end of MCC88.C */
