;/* 	
;**	Functions for low-level support
;**	(C) 1992 R. Pragana 
;*/
;	Static Name Aliases
;
	TITLE   mclowlvl
;	NAME    mclowlvl.C

	.287
MCCNTRL_TEXT	SEGMENT  BYTE PUBLIC 'CODE'
MCCNTRL_TEXT	ENDS
_DATA	SEGMENT  WORD PUBLIC 'DATA'
_DATA	ENDS
_BSS	SEGMENT  WORD PUBLIC 'BSS'
_BSS	ENDS
$$SYMBOLS	SEGMENT  BYTE PUBLIC 'DEBSYM'
$$SYMBOLS	ENDS
$$TYPES	SEGMENT  BYTE PUBLIC 'DEBTYP'
$$TYPES	ENDS
DGROUP	GROUP	_BSS,	_DATA
	ASSUME  CS: MCCNTRL_TEXT, DS: DGROUP, SS: DGROUP, ES: DGROUP
MCCNTRL_TEXT      SEGMENT
;
	PUBLIC	_disable
_disable	PROC FAR
		cli
		ret	
_disable	ENDP

	PUBLIC	_enable
_enable	PROC FAR
	sti
	ret	
_enable	ENDP

	public	_inportb
_inportb	proc far
;	arg	portid:word
	push	bp
	mov	bp,sp
	mov	dx,word ptr [bp+6]
	in	al,dx
	xor	ah,ah
	pop	bp
	ret
_inportb	endp

	PUBLIC	_outportb
_outportb	PROC FAR
;	arg	portid:word,value:byte
	push	bp
	mov	bp,sp
	push	dx
;	mov	dx,[portid]
	mov	dx,word ptr [bp+6]
;	mov	al,[value]
	mov	al,byte ptr [bp+8]
	out	dx,al
	pop	dx
	pop	bp
	ret	
_outportb ENDP

	PUBLIC	_exit_paragraph
_exit_paragraph proc far
;	arg	loc_off:word, high_off:word, low_off:word
	push	bp
	mov	bp,sp
;	mov	ax,[loc_off]
	mov	ax,word ptr [bp+6]
;	cmp	ax,[low_off]
	cmp	ax,word ptr [bp+10]
	jb	ex1
;	cmp	ax,[high_off]
	cmp	ax,word ptr [bp+8]
	jb	ex2
ex1:	pop	bp
	add	sp,10
	ret
ex2:	pop	bp
	ret
_exit_paragraph endp

registers struc
r_cs	dw	?
r_ip	dw	?
r_bx	dw	?
r_cx	dw	?
r_dx	dw	?
r_bp	dw	?
r_ds	dw	?
r_es	dw	?
r_ss	dw	?
r_sp	dw	?
r_si	dw	?
r_di	dw	?
registers ends

	PUBLIC _save_context
_save_context proc far
;	arg	regs:far
	push	bp
	mov	bp,sp
	push	si
	push	es
;	les	dx,[regs]
	les	si,dword ptr [bp+6]
	mov	es:[si].r_di,di
	mov	es:[si].r_bx,bx
	mov	es:[si].r_cx,cx
	mov	es:[si].r_dx,dx
	mov	ax,ds
	mov	es:[si].r_ds,ax
	mov	ax,ss
	mov	es:[si].r_ss,ax
	mov	ax,[bp]
	mov	es:[si].r_bp,ax
	mov	ax,[bp+2]
	mov	es:[si].r_ip,ax
	mov	ax,[bp+4]
	mov	es:[si].r_cs,ax
	mov	ax,sp
	add	ax,10		; subtract es,dx,bp,ip & cs on the stack
	mov	es:[si].r_sp,ax
	mov	ax,[bp-2]
	mov	es:[si].r_si,ax
	mov	ax,[bp-4]
	mov	es:[si].r_es,ax
	xor	ax,ax
	pop	es
	pop	si
	pop	bp
	ret
_save_context endp

	PUBLIC _restore_context
_restore_context proc far
	push	bp
	mov	bp,sp
	les	si,dword ptr [bp+6]
	cli
	mov	ax,es:[si].r_ss
	mov	ss,ax
	mov	ax,es:[si].r_sp
	mov	sp,ax
	sti
	mov	ax,es:[si].r_cs
	push	ax
	mov	ax,es:[si].r_ip
	push	ax
	mov	ax,es:[si].r_si
	push	ax
	mov	ax,es:[si].r_es
	push	ax
	mov	bx,es:[si].r_bx
	mov	cx,es:[si].r_cx
	mov	dx,es:[si].r_dx
	mov	ds,es:[si].r_ds
	mov	di,es:[si].r_di
	mov	bp,es:[si].r_bp
	pop	es
	pop	si
	mov	ax,1
	ret
_restore_context endp

wordregs struc
x_ax	dw	?
x_bx	dw	?
x_cx	dw	?
x_dx	dw	?
x_si	dw	?
x_di	dw	?
x_cflag	dw	?
wordregs ends

sregs struc
s_es	dw	?
s_cs	dw	?
s_ss	dw	?
s_ds	dw	?
sregs ends

	public __intdosx
__intdosx proc far
;	arg	inregs:dword,outregs:dword,sregs:dword
	push	bp
	mov	bp,sp
	push	si
	push	di
	push	ds
	lds	di,[bp+6]		; &inregs
	mov	ax,[di].x_ax
	mov	bx,[di].x_bx
	mov	cx,[di].x_cx
	mov	dx,[di].x_dx
	mov	si,[di].x_si
	push	word ptr [di].x_si	; salva DI temporariamente
	lds	di,[bp+14]		; &sregs
	mov	es,[di].s_es
	mov	ds,[di].s_ds
	pop	di			; recupera DI
	int	21h			; call MsDos
	pushf				; salva flags,di,ds retornados
	push	di
	push	ds
	lds	di,[bp+14]		; &sregs
	mov	[di],es
	pop	word ptr [di].s_ds
	lds	di,[bp+10]		; &outregs
	mov	[di].x_ax,ax
	mov	[di].x_bx,bx
	mov	[di].x_cx,cx
	mov	[di].x_dx,dx
	mov	[di].x_si,si
	pop	word ptr [di].x_di
	pop	word ptr [di].x_cflag	
	pop	ds
	pop	di
	pop	si
	pop	bp
	ret
__intdosx endp

	public _move_bytes
_move_bytes proc far
;	arg	dest:dword,src:dword,len:word
	push	bp
	mov	bp,sp
	mov	cx,[bp+14]	; len
	cmp	cx,0
	jz	mov9
	push	si
	push	di
	push	ds
	push	es
	pushf
	lds	si,[bp+10]	; src
	les	di,[bp+6]	; dest
	cmp	si,di
	jb	mov2
	cld
mov1:	rep movsb
	jmp	mov4
mov2:	std
	add	si,cx
	dec	si
	add	di,cx
	dec	di
mov3:	rep movsb
mov4:	popf
	pop	es
	pop	ds
	pop	di
	pop	si
mov9:	pop	bp
	ret	
_move_bytes endp

MCCNTRL_TEXT	ENDS
END
