/*
**  Cobol Compiler Library -- Math Module
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	29-oct-91 Code implementation
**	24-dec-91 Separate library for files
**
*/

#include "mcoblib.h"
#include <math.h>

#define min(x,y) ((x)<(y) ? (x) : (y))

void fldtod( struct fld_desc *, char *, double * );
extern double fp1;
extern double fp2;
extern double fp3;

/*void dump_double( msg,ptr )
char *msg;
unsigned char *ptr;
{
	int i;
	mprintf(msg);
	ptr+=7;
	for (i=0;i<8;i++)
		mprintf("%02.2x",*ptr--);
	mgetkey();
}*/

int compare( f1,s1,f2,s2 )
struct fld_desc *f1;
char *s1;
struct fld_desc *f2;
char *s2;
{
/*********** retorna 1 se s1>s2; 0 se s1==s2; -1 se s1<s2 **********/
	int i,maxi;
    if ((f1->type!='9' && f1->type!='C') ||
	(f2->type!='9' && f2->type!='C')) {  /* compare strings */
	maxi=(f1->len<f2->len)?f1->len:f2->len;
	for (i=0;;i++) {
		if (i>=maxi) break;
		if (*(s1+i) == *(s2+i)) continue;
		if (*(s1+i) >  *(s2+i)) return 1;
		if (*(s1+i) <  *(s2+i)) return -1;
	}
	if (f1->len>f2->len) {
		while (i<f1->len)
			if (*(s1+i++)!=' ') return 1;
		return 0;
	}
	else {
		while (i<f2->len)
			if (*(s2+i++)!=' ') return -1;
		return 0;
	}
    }
    else {
	fldtod(f1,s1,&fp1);
	fldtod(f2,s2,&fp2);
	if (fp1>fp2) return 1;
	if (fp2>fp1) return -1;
	return 0;
    }
}

/* end of MCCOND.C */
