/*
**  Cobol Compiler Library -- File Handling Module
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	29-oct-91 Code implementation
**	24-dec-91 Separate library for files
**
*/

#include "mcoblib.h"
#include "math.h"

#define min(x,y) ((x)<(y) ? (x) : (y))
#define PRN_HANDLE *((int *)&(v->filepos))

int spool_number=0;
extern char current_dir[];

void open_prn( prn_port,f,v )
int prn_port;
struct file_desc *f;
struct var_fd *v;
{
	char fname[65],tmp[20];
	v->splrec = spool_number++;
	strcpy(fname,current_dir);
	sprintf(tmp,"SPL%05d\.\$MT",v->splrec);
	strcat(fname,tmp);
	PRN_HANDLE = _creat(fname,0);
	f->organization=4; /* special for spooler */
	f->users=prn_port; /* where to save prn_port */
}
