/*
**  Cobol Compiler Library -- File Handling Module
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	29-oct-91 Code implementation
**	24-dec-91 Separate library for files
**
*/

#include "mcoblib.h"
#include "math.h"

#define min(x,y) ((x)<(y) ? (x) : (y))
#define PRN_HANDLE *((int *)&(v->filepos))

extern char current_dir[];

int mc_read_prev( f,v )
struct file_desc *f;
struct var_fd *v;
{
	int rt;
    check_open(f);
    if (f->organization==3) {
		/* relative */
		rt=(int)_lseek(f->handle,v->filepos,SEEK_SET);
		if (rt==-1) return 31; /* seek error */
		rt = _read( f->handle, RECORD, f->reclen );
		if (rt==0) return 10; /* end of file */
		if (rt==-1) return 30; /* read error */
		return 0;
	}
    move_bytes( v->e.key,RECORD+f->rec_index,f->ixd_desc->len);
    *(v->e.key+f->ixd_desc->len)=0;
    if (!locate_key( &(v->e),&(f->index)) )
        return 23;
    /*v->filepos = v->e.recptr;*/
    /* local anterior do 'prev_key' abaixo */
    if (prev_key( &(v->e),&(f->index))!=IX_OK) {
            v->filepos = -1;
            return 10;
    }
    else
        v->filepos = v->e.recptr;
    if (_lseek(f->handle,v->filepos,SEEK_SET)==-1) return 30;
	rt=_read( f->handle, RECORD, f->reclen );
	if (rt==0) return 32; /* end of file */
	if (rt==-1) return 30; /* read error */
    return 0;
}
