/*
**  Cobol Compiler Library -- File Handling Module
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	29-oct-91 Code implementation
**	24-dec-91 Separate library for files
**
*/

#include "mcoblib.h"
#include "math.h"

#define min(x,y) ((x)<(y) ? (x) : (y))
#define PRN_HANDLE *((int *)&(v->filepos))

extern char current_dir[];
extern int sortnumber;
extern char *sortdesc;

int sort_release( f,v,sd,... )
struct file_desc *f;
struct var_fd *v;
char *sd;
{
	va_list argp;
	char *fld;
	char *key;
	if (_write(f->handle,RECORD,f->reclen)==-1) return 30;
	sortdesc = sd;
	key = v->e.key;
	va_start( argp,sd );
	while(*sd++) {
		fld = va_arg( argp,char * );
/*mprintf("\fKey: %4.4s,%d",fld,*sd); mgetkey();*/
		move_bytes( key,fld,*sd );
		key += *sd++;
	}
	*key=0;
	v->e.recptr = v->filepos;
	v->filepos += f->reclen;
	if (add_key( &(v->e), &(f->index) )!=IX_OK)
		{ sortdesc=NULL; return 22; }
	sortdesc=NULL;
	return 0;
}
