/*
**  Cobol Compiler Library -- File Handling Module
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	29-oct-91 Code implementation
**	24-dec-91 Separate library for files
**
*/

#include "mcoblib.h"
#include "math.h"

#define min(x,y) ((x)<(y) ? (x) : (y))
#define PRN_HANDLE *((int *)&(v->filepos))

extern char current_dir[];

int write_from( f,v,buf )
struct file_desc *f;
struct var_fd *v;
char *buf;
{
	long seekpos;
	if (f->organization != 4) {
		/* seekpos = _filelength(f->handle); */
		if (_lseek(f->handle,0,SEEK_END)==-1L) return 21;
		seekpos=_tell(f->handle);
	}
	else {
		if (_lseek(f->handle,-1L,SEEK_END)==-1L)
			if (_lseek(f->handle,0,SEEK_END)==-1L) return 21;
	}
	if (_write(f->handle, buf, f->reclen)==-1) return 30;
	if (f->organization==4) /* printer or line sequential */
		_write(f->handle,"\x0d\x0a\x1a",3);
	if (f->organization==1) {
		move_bytes( v->e.key,buf+f->rec_index,
				 f->ixd_desc->len );
		*(v->e.key + f->ixd_desc->len)=0;
			/* null at end of string */
		v->e.recptr = seekpos;
		if (add_key( &(v->e), &(f->index) )!=IX_OK) return 22;
	}
	return 0;
}
