;
;  Rotina auxiliar para processamento de interrupcoes
;
SDKEYA_TEXT	segment	byte public 'CODE'
DGROUP	group	_DATA
	assume	cs:SDKEYA_TEXT,ds:DGROUP
SDKEYA_TEXT	ends

_DATA	segment word public 'DATA'
d@	label	byte
d@w	label	word
_DATA	ends

extrn	_keys_sent:far

SDKEYA_TEXT	segment byte public 'CODE'
	assume	cs:SDKEYA_TEXT,ds:DGROUP

OldInt16W	label	word
OldInt16	dd	0
bufptrW		label	word
bufptr		dd	0
nchars		dw	0

	public	_set_sdkeys_int
_set_sdkeys_int	proc	far
	push	bp
	mov	bp,sp
	mov	ax,word ptr [bp+6]
	mov	word ptr cs:[nchars],ax
	mov	ax,word ptr [bp+8]	; offset bufptr
	mov	word ptr cs:[bufptrW],ax
	mov	ax,word ptr [bp+10]
	mov	word ptr cs:[bufptrW+2],ax
	mov	ax,500h			; write null char
	xor	cx,cx
	int	16h
	push	es			; get OldInt16 at 86 interrupt table
	mov	ax,3516h
	int	21h
	mov	word ptr cs:[OldInt16W],bx
	mov	ax,es
	mov	word ptr cs:[OldInt16W+2],ax
	pop	es
	push	ds			; set new Int16 vector
	mov	ax,cs
	mov	ds,ax
	mov	ax,2516h
	mov	dx,offset SDKEYA_TEXT:_Int16New
	int	21h
	pop	ds
	pop	bp
	ret
_set_sdkeys_int	endp

_Int16New	proc far
	sti
	push	bp
	mov	bp,sp
	cmp	ah,0
	je	c1
	cmp	ah,16
	je	c1
	cmp	ah,1
	je	c2
	cmp	ah,17
	je	c2
	cmp	ah,5
	je	c3
	cmp	ah,2
	je	c4
	cmp	ah,18
	je	c4
			; execute old interrupt 16h
	pop	bp
	jmp	dword ptr cs:[OldInt16]
;
c1:	push	ds
	push	si
	lds	si,dword ptr cs:[bufptr]
	mov	al,[si]
	inc	si
	mov	word ptr cs:[bufptrW],si
	pop	si
	pop	ds
	mov	ah,1
	dec	word ptr cs:[nchars]
	jnz	c99
	push	ax
	push	ds
	push	dx
;
	lds	dx,dword ptr cs:[OldInt16]
	mov	ax,2516h
	int	21h
	pop	dx
	pop	ds
	push	ds
	mov	ax,DGROUP
	mov	ds,ax
	call	far ptr _keys_sent
	pop	ds
;
	pop	ax
	jmp	short c99
c2:	push	ds
	push	si
	lds	si,dword ptr cs:[bufptr]
	mov	al,[si]
	pop	si
	pop	ds
	mov	ah,1
	and	word ptr [bp+6],0ffbfh	; clear zero flag
	jmp	short c99
c3:	mov	ax,1
	jmp	short c99
c4:	xor	ax,ax
	jmp	short c99
c99:	pop	bp
	iret	
_Int16New	endp


SDKEYA_TEXT	ends
	end
