/*
**      Interface to Microsoft Cobol using TSR Multiplex Interrupt (2F)
*/

#define TESTETSR 1

#include "stdio.h"
#include "dos.h"

void SENDTSR( char * );

void SENDTSR( BUFFER )
char *BUFFER;
{
        union REGS iregs,oregs;
        struct SREGS sregs;
	/******** envia a msg ate ser bem sucedido **********/
	do {
		iregs.x.ax = 0xef81;
		iregs.x.dx = FP_OFF(BUFFER);
		sregs.es = FP_SEG(BUFFER);
		int86x( 0x2f,&iregs,&oregs,&sregs );
	} while (oregs.h.al == 0 );
	/****** espera final da operacao do programa residente ********/
	do {
		iregs.x.ax = 0xef82;
		int86( 0x2f,&iregs,&oregs );
	} while (oregs.h.al == 0);
}

#ifdef TESTETSR
char msg[1000];
char chave[80];
void main() {
	int i;
while(1) {
	for (i=0;i<81;i++) msg[i]=' ';
/*
	printf("\nBata <Enter> ou <F>im");
	if (getchar()=='F') break;
*/
	strcpy(msg,"OP00CLIFORN ");
	SENDTSR(msg);
	printf("\nChave:");
	gets(chave);
	if (*chave==0) break;
	strcpy(msg,"RD00CLIFORN ");
	strcpy(msg+12,chave);
	SENDTSR(msg);
	msg[70]=0;
/*
	printf("\n<Enter>...");
	getchar();
*/
	printf("\nRegistro: [%s]\n",msg+2);
	strcpy(msg,"CL00CLIFORN ");
	SENDTSR(msg);
}
}
#endif
/* end of TSRCALL.C */
