/*
**      Interface to Microsoft Cobol using TSR Multiplex Interrupt (2F)
*/

#define TESTETSR 1

#include <dos.h>

void SENDTSR( char * );

void SENDTSR( BUFFER )
char *BUFFER;
{
        union REGS iregs,oregs;
        struct SREGS sregs;
        iregs.x.ax = 0xef81;
        iregs.x.dx = FP_OFF(BUFFER);
        sregs.es = FP_SEG(BUFFER);
        int86x( 0x2f,&iregs,&oregs,&sregs );
}

void CLOSETSR( )
{
        union REGS iregs,oregs;
        iregs.x.ax = 0xef82;
        int86( 0x2f,&iregs,&oregs );
}

#ifdef TESTETSR
char msg[81] = "Se vaivem fosse e viesse vaivem ia, ...";
void main() {
        printf("\nVou enviar msg...\n");
        SENDTSR(msg);
        printf("\nMandei msg ok...\n");
        CLOSETSR();
}
#endif
/* end of TSRCALL.C */
